#include "stdafx.h"
#include <math.h>

#include "AIFRead.h"
#include "AvionicsDoc.h"

#define SMALL_STEP 0.01

CSystem gTheSystem;
CString gEvtsNoSubscriberString;
CString gPEDGCycleMsg;
CString gUnreachableString;
CString gAIFFileNameString;
void ProcessPEDGSuccessors(CPortNode *pNode, set<Event> &events);

//Given a receptacle, get the method name it invokes. this is not strictly correct
//in AIF, since method name should be associated with InvocationConnection between
//receptacle and facet, which is not the case in AIF. so I just grab the first one
CString GetInvocationMethodName(Receptacle *receptacle) {
	set<CallOut> cos = receptacle->co();
	for(set<CallOut>::iterator iCallOut = cos.begin(); iCallOut != cos.end();	iCallOut++) {
		CallOut co = *iCallOut;
		Method method = co.method();
		return CString(string(method.name()).c_str());
	}
	return CString("Not Specified");
}

//This doesnt work for Udm data structures, since AIFObjects are copies
//CTypedPtrMap<CMapStringToPtr, CString, SubscribePort*> SubPortPtrMap;

//Contains pub and subports, but not facets and receptacles.
CTypedPtrMap<CMapStringToPtr, CString, CPortNode*> PortNodeMap;
///////////////////////////////////////////////////////////////////
//If I call this function from MyWorkingThread, it kills the applicaion with an exception
//in 
CDocument *GetDocumentPtr() {
	CWnd *pWnd = AfxGetMainWnd ();

	CFrameWnd* pwndMainFrame = (CFrameWnd*)pWnd;
	//CFrameWnd *pwndActiveFrame = pwndMainFrame->GetActiveFrame ();

	CDocument *pDocument = ((CFrameWnd*) pwndMainFrame) ->GetActiveDocument (); 
	return pDocument;
}

void List::add(List & other) {
	ASSERT(this != &other);
	Node *n = other.get_head();
	while(n) {
		add(n->x);
		n = other.get_next(n);
	}

}

void List::add(int x)
{
	Node *n = find(x);
//TODO
	//	ASSERT(n == NULL);
    Node *temp;
    temp = new Node;
    temp->x = x;
	temp->next = NULL;


        if (size == 0) {
        head = temp;
        tail = temp;


        } else {
        tail->next = temp;
        tail = temp;
    }
    /* Our list is now one size bigger. */
    
    size++; 
    cout << "List::add(" << temp->x << ")." << endl;
}

void List::del(int x) { 
Node *temp = head, *prev = head; 
//for (int i=0; i<size; i++) 
//{
while(temp) {
    if (temp->x == x) {
        prev->next = temp->next; 
        if (head == temp) head = temp->next;
        if (tail == temp) tail = prev;
        temp->next = NULL; 
        delete temp;
       	break;
    } 
    else { 
    prev = temp; 
    temp = temp->next; 
	} 
}
size--; 
cout << "List::del(" << x << ")." << endl;
}

Node *List::find(int x) {
	Node *n = get_head();
	while(n) {
		if(n->x == x) return n;
		n = get_next(n);
	}
	return NULL;
}




void List::print()
{
Node *n = get_head();
while(n) {
	cout << n->x << " " ;
	n = get_next(n);
}

return;
Node *temp;
temp = head; 
cout << "List::print() output: ";


do {
cout << "[" << temp->x << "] --> ";
temp = temp->next; 
} while (temp != NULL);
cout << "NULL" << endl;
}
//FILE *f;
//Memory leak, who cares..
void List::remove_all() {
	size = 0; head = NULL; tail = NULL; 
}

void List::display(FILE *f)
{
	CString cs, temp;
	cs.Format("Size %d:head %d:tail %d: ", size, head ? head->x : -1, tail ? tail->x : -1);
	Node *n = get_head();
	while(n) {
		//temp.Format("%d %s ", n->x, gTheSystem.theCEDG.get_node_name(n->x));
		temp.Format("%d ", n->x);
		cs += temp;
		//cout << n->x << " " ;
		n = get_next(n);
	}
	//AfxMessageBox(cs);
//	fprintf(f, "%s\n", cs);
//	fflush(f);
}


/////////////////////////////////////////////////////////


wdigraph::wdigraph(graph_type_t Type) : type(Type)
{
// Initialize to graph with N vertices and no edges.
    if(Type == PEDG) {
		N = MAX_PORTS; M = MAX_PORT_CONN;
	} else if(Type == CEDG) {
		N = MAX_COMPONENTS; M = MAX_COMPONENT_CONN;
	} else if(Type == TASKGRAPH) {
		N = MAX_TASKS; M = MAX_TASK_CONN;
	} else 
		ASSERT(false);
	reset();
}

void wdigraph::reset() {
	edges = new wdgedge[M+1];
	vertices = new wdgvertex[N+1];
	n = 0; m = 0;
	for (vertex u = 1; u <= N; u++) {
		set_firstout(u, 0);
		set_firstin(u, 0);
		set_color(u, WHITE);
//		vertices[u].invalid = false;
//		vertices[u].is_cluster_head = false;
	}
	for(edge e = 1; e <= M; e++) {
		edges[e].h = edges[e].t = 0;
		edges[e].wt = 0;
		edges[e].hnext = edges[e].tnext = 0;
//		edges[e].invalid = false;
	}
/*
	for(u = 1; u <= N; u++) {
		vertices[u].merged_vertices.add(u);
		//cout << "constructor   size" << vertices[u].merged_vertices.getSize() << endl;
	}
	*/
}

void wdigraph::reset_color() {
	for(vertex u = 0; u < N; u++) {
		set_color(u, WHITE);
	}
}

wdigraph::~wdigraph() { delete [] vertices; delete [] edges; }
#if 0
wdigraph::wdigraph(const wdigraph & graph) {
	type = graph.type;
	N = graph.N;
	M = graph.M;
	edges = new wdgedge[M+1];
	vertices = new wdgvertex[N+1];

	n = graph.n;
	m = graph.m;
	for(vertex v = 1; v <= N; v++) {
		vertices[v] = graph.vertices[v];
	}

	for(edge e = 1; e <= M; e++) {
		edges[e] = graph.edges[e];
	}
}
#endif

CString wdigraph::get_node_name(vertex v) {
	CPortNode *pNode = NULL;
	CComponentNode *cNode = NULL;
	CTaskNode *tNode = NULL;
	CString str;
	switch (type) {
	case PEDG:
		pNode = (CPortNode *) vertices[v].data;
		cNode = pNode->parentComp;
		ASSERT(cNode && pNode);
		str = cNode->name + "." + pNode->GetName();
		return str;
	case CEDG:
		cNode = (CComponentNode *) vertices[v].data;
		return cNode->name;
	case TASKGRAPH:
		tNode = (CTaskNode *) vertices[v].data;
		ASSERT(tNode && tNode->parentProcessor);
		return tNode->parentProcessor->name + "." + tNode->GetName();
	}
	ASSERT(false);
	return CString("");
}


int wdigraph::join(vertex u, vertex v, weight W) {
// Join u and v with edge of given weight. Return edge number.
	edges[++m].t = u; edges[m].h = v; edges[m].wt = W;
	edges[m].tnext = firstout(u); set_firstout(u, m);
	edges[m].hnext = firstin(v); set_firstin(v, m);
	return m;
}

void wdigraph::bldadj() {
// Build adjacency lists.
	for (vertex u = 1; u <= n; u++) {
		set_firstout(u, 0);
		set_firstin(u, 0);
	}
	for (edge e = m ; e >= 1; e--) {
		edges[e].tnext = firstout(edges[e].t);
		set_firstout(edges[e].t, e);
		edges[e].hnext = firstin(edges[e].h);
		//fin[edges[e].h] = e;
		set_firstin(edges[e].h, e);
	}
}

void wdigraph::putDotty(const char *fileName) {
	ASSERT(edges);
	FILE *f = fopen(fileName, "w");
	fprintf(f, "digraph G{\n");
	fprintf(f, "size=\"7.5,10\"\n");
	fprintf(f, "page=\"8.5,11\"\n");
	fprintf(f, "nodesep=0.1\n");
	fprintf(f, "node [shape=box,height=.2,width=.1,fontname=Tahoma]\n");
	for(vertex v = 1; v <= n; v++) {
		fprintf(f, "\"%s\"[style=filled];\n", get_node_name(v));
	}
	

	for (edge e = 1; e <= m; e++) {
		fprintf(f, "\"%s\" -> \"%s\"", get_node_name(tail(e)),
				get_node_name(head(e)));
		//turning on the edge labels produces a messy diagram, take out for now
		//style=dotted filled do not work right
		//fprintf(f, "[label=\"%s\", ", get_edge_name(e));
		if(get_edge_type(e) == INVOCATION || get_edge_type(e) == REPLICATION) {
			fprintf(f, "[style=dotted];\n");
		} else {
			fprintf(f, "[style=filled];\n");
		}
	}
	fprintf(f, "};\n"); 
	fclose(f);
	return;
#if 0
	//Group components into processors produces a messy diagram. so take out for now
	if(type == CEDG) {
/*		POSITION pos = gTheSystem.processorNodeList.GetHeadPosition();
		int counter = 0;
		while(pos) {
			CProcessorNode *pNode = gTheSystem.processorNodeList.GetNext(pos);
			fprintf(f, "subgraph cluster%d {\n", counter++);
			POSITION pos2 = pNode->components.GetHeadPosition();
			while(pos2) {
				CComponentNode *cNode = pNode->components.GetNext(pos2);*/
		POSITION pos = gTheSystem.compNodeList.GetHeadPosition();
		while(pos) {
				CComponentNode *cNode = gTheSystem.compNodeList.GetNext(pos);
				fprintf(f, "\"%s\"", cNode->name);
				if(cNode->type == MASTER) {
					fprintf(f, "[style=filled];\n");
				} else {
					fprintf(f, "[style=dotted];\n");
				}
			/* Now that we have artifical CComponnentNode for timers, we do not need below.
				if(cNode->timerTriggered) {
					CString timerName = GetNameFromRate(cNode->rate) + "Timer" + "_" + pNode->name;
					fprintf(f, "\"%s\" -> \"%s\"", timerName, cNode->name);
					fprintf(f, "[style=filled];\n");
					//fprintf(f, "{rank = source;\"%s\"}\n", timerName);
				}
				*/
			}
			
			fprintf(f, "label=\"%s\";\n", pNode->name);
			fprintf(f, "}\n");
		} 
	} else if(type == PEDG) {
		for(vertex v = 1; v <= n; v++) {
			fprintf(f, "\"%s\";\n", get_node_name(v));
		}
	} else if(type == TASKGRAPH) {
		for(vertex v = 1; v <= n; v++) {
			fprintf(f, "\"%s\"[shape=parallelogram];\n", get_node_name(v));
		}
	}
#endif

#if 0
		/*
		fprintf(f, "\"%s\" -> \"%s\"[label=\"%d %s\"]\n", get_node_name(tail(e)),
			get_node_name(head(e)), get_edge_wt(e), get_edge_name(e));
			*/
		//If connection is the typical control-push, data-pull, then draw an arrow
		//bidirectional arrow. But if connection is pure invocation with no reverse
		//event, then just draw a single-direction arrow.
		if(get_edge_type(e) != INVOCATION) {
			fprintf(f, "\"%s\" -> \"%s\"", get_node_name(tail(e)),
				get_node_name(head(e)));
			edge ereverse = edge_exists(head(e), tail(e));
			if(ereverse != -1 && get_edge_type(ereverse) == INVOCATION) {
				fprintf(f, "[arrowtail=inv]\n");
			} else {
				fprintf(f, "\n");
			}
		} else {
			edge ereverse = edge_exists(head(e), tail(e));
			if(ereverse == -1) {
				fprintf(f, "\"%s\" -> \"%s\"[style=dotted]\n", get_node_name(tail(e)),
				get_node_name(head(e)));
			}
		}
		/*
		if(get_edge_type(e) == REPLICATION || get_edge_type(e) == INVOCATION) {
			fprintf(f, "[style=dotted];\n");
		} else {
			fprintf(f, "[style=filled];\n");
		}*/
	}
#endif

}

#if 0
//Replace processorNodeList with newProcessorNodeList
//replace pNode->components with pNode->components_allocation
void wdigraph::putDottyAllocation(const char *fileName) {
	ASSERT(edges);
	ASSERT(type == CEDG);
	FILE *f = fopen(fileName, "w");
	fprintf(f, "digraph G{\n");
	fprintf(f, "size=\"7.5,10\"\n");
	fprintf(f, "page=\"8.5,11\"\n");
	fprintf(f, "nodesep=0.1\n");
	fprintf(f, "node [shape=box,height=.2,width=.1,fontname=Tahoma]\n");
	//Group components into processors. But it produces a messy diagram. so take out for now
	if(type == CEDG) {
		POSITION pos = gTheSystem.newProcessorNodeList.GetHeadPosition();
		int counter = 0;
		while(pos) {
			CProcessorNode *pNode = gTheSystem.newProcessorNodeList.GetNext(pos);
			fprintf(f, "subgraph cluster%d {\n", counter++);
			POSITION pos2 = pNode->components_allocation.GetHeadPosition();
			while(pos2) {
				CComponentNode *cNode = pNode->components_allocation.GetNext(pos2);
				fprintf(f, "\"%s\"", cNode->name);
				if(cNode->type == MASTER) {
					fprintf(f, "[style=filled];\n");
				} else {
					fprintf(f, "[style=dotted];\n");
				}
			/* Now that we have artifical CComponnentNode for timers, we do not need below.
				if(cNode->timerTriggered) {
					CString timerName = GetNameFromRate(cNode->rate) + "Timer" + "_" + pNode->name;
					fprintf(f, "\"%s\" -> \"%s\"", timerName, cNode->name);
					fprintf(f, "[style=filled];\n");
					//fprintf(f, "{rank = source;\"%s\"}\n", timerName);
				}
				*/
			}
			
			fprintf(f, "label=\"%s\";\n", pNode->name);
			fprintf(f, "}\n");
		} 
	} 

	for (edge e = 1; e <= m; e++) {
		/*
		fprintf(f, "\"%s\" -> \"%s\"[label=\"%d %s\"]\n", get_node_name(tail(e)),
			get_node_name(head(e)), get_edge_wt(e), get_edge_name(e));
			*/
		//If connection is the typical control-push, data-pull, then draw an arrow
		//bidirectional arrow. But if connection is pure invocation with no reverse
		//event, then just draw a single-direction arrow.
		if(get_edge_type(e) != INVOCATION) {
			fprintf(f, "\"%s\" -> \"%s\"", get_node_name(tail(e)),
				get_node_name(head(e)));
			edge ereverse = edge_exists(head(e), tail(e));
			if(ereverse != -1 && get_edge_type(ereverse) == INVOCATION) {
				fprintf(f, "[arrowtail=inv]\n");
			} else {
				fprintf(f, "\n");
			}
		} else {
			edge ereverse = edge_exists(head(e), tail(e));
			if(ereverse == -1) {
				fprintf(f, "\"%s\" -> \"%s\"[style=dotted]\n", get_node_name(tail(e)),
				get_node_name(head(e)));
			}
		}
		/*
		if(get_edge_type(e) == REPLICATION || get_edge_type(e) == INVOCATION) {
			fprintf(f, "[style=dotted];\n");
		} else {
			fprintf(f, "[style=filled];\n");
		}*/
	}
	fprintf(f, "}\n"); 
	fclose(f);
}

void wdigraph::putDottyMerged(const char *fileName) {
	FILE *f = fopen(fileName, "w");
	ASSERT(f);
	fprintf(f, "digraph G{\n");
	int counter = 1;
	for(vertex v = 1; v <= n; v++) {
		if(firstout(v) == 0 && firstin(v) == 0 &&
			vertices[v].merged_vertices.get_size() == 1) 
			continue;
		fprintf(f, "subgraph cluster%d {\n", counter++);
		Node *n = vertices[v].merged_vertices.get_head();
		while(n) {
			fprintf(f, "  %s;", get_node_name(n->x));
			n = vertices[v].merged_vertices.get_next(n);
		}
		fprintf(f, "}\n");
	}
	for (edge e = 1; e <= m; e++) {
		if(edges[e].invalid) continue;
		fprintf(f,"%2s->%2s\n", get_node_name(tail(e)),
			get_node_name(head(e)));
	}
	fprintf(f, "}\n");
	fclose(f);
}
#endif
//returns a string to display in the CAllocationResultsDlg dialog.
//outer loop: iterate through all the clusters resulting from component to processor
//allocation.
//inner loop: iterate through processors to find corresponding processor that
//the components are allocated to. since it's a graphcut algo, doesnt matter which processor.
CString wdigraph::getAllocationResultStr() {
	ASSERT(type == CEDG);
	CString m_strAllocResults;
#if 0
	int count1 = 0, count2 = 0;

	for(vertex v = 1; v <= n; v++) {
	/*	if(firstout(v) == 0 && firstin(v) == 0 &&
			vertices[v].merged_vertices.get_size() == 1) 
			continue;*/
		if(vertices[v].invalid) continue;
		count1++;
/*
		CProcessorNode *pNode = NULL;
		count2 = 0;
		POSITION pos2 = gTheSystem.processorNodeList.GetHeadPosition();
		while(pos2) {
			pNode = gTheSystem.processorNodeList.GetNext(pos2);
			count2++;
			if(count2 == count1) break;
		}
		ASSERT(pNode);
		m_strAllocResults += pNode->name;
		m_strAllocResults += ":\r\n";
*/
		CString temp;
		temp.Format("Cluster %d with components:\n ", count1);
		m_strAllocResults += temp;

		Node *n = vertices[v].merged_vertices.get_head();
		while(n) {
			m_strAllocResults +=  get_node_name(n->x);
			m_strAllocResults += ",";
			n = vertices[v].merged_vertices.get_next(n);
		}
		m_strAllocResults += "\r\n";
	}
#endif 
	POSITION pos = gTheSystem.processorNodeList.GetHeadPosition();
	while(pos) {
		CProcessorNode *pNode = gTheSystem.processorNodeList.GetNext(pos);
		POSITION pos2 = pNode->components.GetHeadPosition();
		m_strAllocResults += pNode->name;
		m_strAllocResults += ":";
		while(pos2) {
			CComponentNode *cNode = pNode->components.GetNext(pos2);
			m_strAllocResults += cNode->name;
			m_strAllocResults += ",";
		}
		m_strAllocResults += "\r\n";
	}
	return m_strAllocResults;
}



bool wdigraph::CheckCycles() {
//	f = fopen("c:\\temp\\crap.txt", "w");
	reset_color();
	gPEDGCycleMsg.Empty();
	for(vertex v = 1; v <= n; v++) {
		if(get_color(v) == WHITE) {
			DFSVisitCheckCycles(v);
		}
	}
	return !gPEDGCycleMsg.IsEmpty(); 
}


void wdigraph::DFSVisitCheckCycles(vertex u) {
//	fprintf(f, "adding %d\n", u);
//	fflush(f);
	DFSPath.add(u);
//	DFSPath.display(f);
	set_color(u, GRAY);
	
	edge e = firstout(u);
	while(e) {
		vertex v = head(e);
		if(GRAY == get_color(v)) {
			//Pass in v instead of u, since u is the end of the list.
			//AfxMessageBox("There is cycles ");
			gPEDGCycleMsg += PrintCycleMsg(v);
		} else if(WHITE == get_color(v)) {
			DFSVisitCheckCycles(v);
		}
		e = nextout(e);
	}
//	fprintf(f, "deleting %d\n", u);
//	fflush(f);
	DFSPath.del(u);
//	DFSPath.display(f);
	set_color(u, BLACK);
}

//This is run on CEDG, for allocation of components to processors.

void wdigraph::BFSVisit(vertex u) {
	FILE *f = fopen("c:\\temp\\bfstrace.txt", "a");
	List frontier_nodes;
	
	set_color(u, GRAY);
	frontier_nodes.add(u);
	while(frontier_nodes.get_size()) {
		Node *headNode = frontier_nodes.get_head();
		ASSERT(headNode);
		edge e = firstout(headNode->x);
		while(e) {
			//For BFS search, only traverse event edges
			if(get_edge_type(e) == EVENT) {
				vertex v = head(e);
				if(get_color(v) == WHITE) {
					set_color(v, GRAY);
					frontier_nodes.add(v);
				}
			}
			e = nextout(e);
		}

		ASSERT(get_color(headNode->x) == GRAY);
		set_color(headNode->x, BLACK);
		fprintf(f, "%d %s\n ", headNode->x, get_node_name(headNode->x));
		fflush(f);
		CComponentNode *cNode = get_comp_node(headNode->x);
		ASSERT(cNode);
		//TimerComponents are not real components, and are not targets for allocation.
		if(!cNode->isTimer) {
			BFSSortedNodes.add(headNode->x);
		}
		frontier_nodes.del(headNode->x);
	}
	fclose(f);
}


#if 0
void wdigraph::assignvertexwts() {
	for(vertex v = 1; v <= n; v++) {
		vertices[v].wt = 0;
	}

	for (edge e = m; e >= 1; e--) {
		if(edges[e].invalid) continue;
		vertices[head(e)].wt += edges[e].wt;
		vertices[tail(e)].wt += edges[e].wt;
	}
}

//Find vertex with max weight. If a vertex doesnot have any valid
//adjacent edges, getmaxedge(v) == -1, then dont use it. 
vertex wdigraph::getmaxvertex() {
	int maxwt = 0;
	vertex maxvertex = -1;
	for(vertex v = 1; v <= n; v++) {
		if(!vertices[v].invalid && vertices[v].wt > maxwt &&
			getmaxedge(v) != -1) {
			maxwt = vertices[v].wt;
			maxvertex = v;
		}
	}
	//ASSERT(maxvertex != -1);
	return maxvertex;
}

//during the graph merging process, it is possible to create a self-loop
//in the graph. ignore such kind of edges when getmaxedge. head(eout) != tail(eout)
edge wdigraph::getmaxedge(vertex v) {
	weight maxwt = -1;
	edge maxedge = -1;
	edge eout = firstout(v);
	while(eout) {
		if(!edges[eout].invalid &&
			edges[eout].wt > maxwt &&
			head(eout) != tail(eout)) {
			maxwt = edges[eout].wt;
			maxedge = eout;
		}
		eout = nextout(eout);
	}

	edge ein = firstin(v);
	while(ein) {
		if(!edges[ein].invalid &&
			edges[ein].wt > maxwt &&
			head(ein) != tail(ein)) {
			maxwt = edges[ein].wt;
			maxedge = ein;
		}
		ein = nextin(ein);
	}
	//ASSERT(maxedge != -1);
	return maxedge;
}

void wdigraph::bubble_sort(vertex cluster[], int sizeofarray)
{
int i,j;
vertex temp;

for(i=sizeofarray-1; i>=0; --i)              // For each spot in the array
    {
                                     //   (starting at the top)
    for(j=0; j<i; j++)                     // Walk through the array to that
        {
                                 //   spot
        if(vertices[cluster[j]].merged_vertices.get_size() > 
			vertices[cluster[j+1]].merged_vertices.get_size() )    // At each location, compare the 
            {
                             //   two adjacent elements
            temp = cluster[j];
           // Swapp elements as needed
            cluster[j] = cluster[j+1];
            cluster[j+1] = temp;
            }
        }
    }
return;
}

#define MAX_CLUSTERS 100
void wdigraph::mincut(int numClusters, double maxutil, int maxcomps) {
	mincutf = fopen("c:\\temp\\mincuttrace.txt", "w");
	assignvertexwts();
	int numC = n;
	while(numC > numClusters) {
		vertex v = getmaxvertex();
		if(v == -1) {
			CString cs;
			cs.Format("End of mincut, total clusters %d, Total CPUs %d", 
				numC, numClusters);
			AfxMessageBox(cs);
			break;
		} else {
			edge e = getmaxedge(v);
			ASSERT(e != -1);
			merge(e);
			numC--;
		}
	}
	fclose(mincutf);
	//total numer clusters >= total number CPUs
	ASSERT(numC >= numClusters);

	vertex clusters[MAX_CLUSTERS];
	int actualNumClusters = 0;
	for(vertex v = 1; v <= n; v++) {
		if(vertices[v].invalid) continue;
		clusters[actualNumClusters++] = v;
	}

	ASSERT(actualNumClusters == numC);

	//If total number of clusters == total numer of CPUs, then just allocate each cluster to
	//each CPU
	if(numC == numClusters) {
		int count = 0;
		POSITION pos = gTheSystem.processorNodeList.GetHeadPosition();
		while(pos) {
			CProcessorNode *pNode = gTheSystem.processorNodeList.GetNext(pos);
			pNode->components.RemoveAll();
			
			Node *n = vertices[clusters[count]].merged_vertices.get_head();
			while(n) {
				CComponentNode *cNode = get_comp_node(n->x);
				pNode->components.AddTail(cNode);
				n = vertices[clusters[count]].merged_vertices.get_next(n);
			}
			count++;
		}
	} else {
		//If we have more clusters than CPUs, then sort the cluster list, and add cluster
		//to CPU until the max number of components/CPU is exceeded.
		bubble_sort(clusters, numC);
		int count = 0;
		POSITION pos = gTheSystem.processorNodeList.GetHeadPosition();
		while(pos) {
			CProcessorNode *pNode = gTheSystem.processorNodeList.GetNext(pos);
			while(pNode->components.GetCount() <= maxcomps) {
				Node *n = vertices[clusters[count]].merged_vertices.get_head();
				while(n) {
					CComponentNode *cNode = get_comp_node(n->x);
					pNode->components.AddTail(cNode);
					n = vertices[clusters[count]].merged_vertices.get_next(n);
				}
				count++;
				if(count >= numC) break;
			}
		}
	}
	/*
	FILE *f = fopen("c:\\temp\\test.dot", "w");
	putDotty(f);
	fclose(f);
	*/
}

//merge head into tail. head is marked invalid, and added to the tail's
//list of vertices.
void wdigraph::merge(edge e1) {
	//The following algo causes a hole in the edge list, need to add an invalid
	//flag to each edge.
	CString temp;
	temp.Format("Merging %d and %d ", tail(e1), head(e1));
//	AfxMessageBox(temp);
	//cout << "merging " << tail(e1) << " " << head(e1) << endl;
	edges[e1].invalid = true;
	vertices[head(e1)].invalid = true;

	fprintf(mincutf, "Begin merging tail %d %s and head %d %s\n", tail(e1), get_node_name(tail(e1)),
		head(e1), get_node_name(head(e1)));
	vertices[tail(e1)].merged_vertices.display(mincutf);
	vertices[head(e1)].merged_vertices.display(mincutf);
	vertices[tail(e1)].merged_vertices.add(vertices[head(e1)].merged_vertices);
	vertices[tail(e1)].merged_vertices.display(mincutf);
	fprintf(mincutf, "End\n");
/*
	for (edge e = 1; e <= m; e++) {
		if(edges[e].invalid) continue;
		if(tail(e) == head(e1)) {
			edges[e].t = tail(e1);
		}
		if(head(e) == head(e1)) {
			edges[e].h = tail(e1);
		}
	}
	
	for(edge e11 = 1; e11 <= m; e11++) {
		if(edges[e11].invalid) continue;
		for(edge e22 = e11 + 1; e22 <= m; e22++) {
			if(edges[e22].invalid) continue;
			if(head(e11) == head(e22) && tail(e11) == tail(e22)) {
				edges[e22].invalid = true;
				edges[e11].wt += edges[e22].wt;
			}
		}
	}
*/
	edge e = firstout(head(e1));
	while(e) {
		edges[e].t = tail(e1);
		e = nextout(e);
	}

	e = firstin(head(e1));
	while(e) {
		if(e != e1) {
			edges[e].h = tail(e1);
		}
		e = nextin(e);
	}
	bldadj();
}
#endif
edge wdigraph::edge_exists(vertex u, vertex v) {
	edge e = firstout(u);
	while(e) {
		if(v == head(e)) return e;
		e = nextout(e);
	}
	return -1;
}

//This function assumes backend has been opened with an AIF file.
void CSystem::Initialize(Udm::SmartDataNetwork* backend) {
//	backend = new Udm::SmartDataNetwork(AIF::diagram);
	System system = System::Cast(backend->GetRootObject());
	ConstructTheSystem(system);
//	TimingAnalysis();
	//gTheSystem.theCEDG.putDotty("c:\\temp\\testy2.dot");
//	gTheSystem.Dump("C:\\temp\\dump.txt");
	
	gAIFFileOpened = false;
	

//	CAvionicsDoc *pDoc = (CAvionicsDoc *) GetDocumentPtr();
//	pDoc->TreeView->Populate();
}

//FILE *temp;
void CSystem::AssignRatesToPEDG() {
//	temp = fopen("c:\\temp\\dfsvisit.txt", "w");

	thePEDG.reset_color();
	int n1 = compNodeList.GetCount();
	POSITION pos = compNodeList.GetHeadPosition();
	while(pos) {
		CComponentNode *cNode = compNodeList.GetNext(pos);
		
		if(cNode->isTimer) {
			POSITION pos2 = cNode->ports.GetHeadPosition();
			while(pos2) {
				CPortNode *pNode = cNode->ports.GetNext(pos2);
				ASSERT(pNode->isTimer);
				thePEDG.DFSVisitAssignRates(pNode->index, pNode->rate);
			}
		}
	}

//	fclose(temp);
	//Provide warnnings to the user on components unreachable from timer.
	pos = compNodeList.GetHeadPosition();
	while(pos) {
		CComponentNode *cNode = compNodeList.GetNext(pos);
		cNode->util = 0.0;
		POSITION pos2 = cNode->ports.GetHeadPosition();
		while(pos2) {
			CPortNode *pNode = cNode->ports.GetNext(pos2);
			if(pNode->rate == UNASSIGNED) {
				gUnreachableString = gUnreachableString + pNode->parentComp->name + "." + 
					pNode->GetName() + "\r\n";
			}
			//Update each componentNode util param from its subport params, used in component
			//allocation to processors.
			//HACK: do not add together all port WCETs, turns out only one port is good
			//otherwise, unnecessarily high utilization for a component with multiple ports
			else if(pNode->type == SUBSCRIBEPORT || pNode->type == FACET) {
				if(pNode->wcet > 0) {
					cNode->util = pNode->wcet / GetPeriodFromRate(pNode->rate);
					break;
				}
			}
		}
	}

	//Recalculate task WCETS based on rate assignment. Also add ports to tasknodes.
	pos = gTheSystem.processorNodeList.GetHeadPosition();
	while(pos) {
		CProcessorNode *pNode = gTheSystem.processorNodeList.GetNext(pos);
		pNode->CalculateTaskWCET();
	}

	//Calculate Component Util parameter.

}


//How to deal with multi-rate components? For now, fudge it, and let the highest
//rate propogate thru by traversing the highest rate component before others.	
#if 0
void CSystem::AssignRatesToCEDG() {
//	temp = fopen("c:\\temp\\crappy.txt", "w");

	theCEDG.reset_color();

	POSITION pos = compNodeList.GetHeadPosition();
	while(pos) {
		CComponentNode *cNode = compNodeList.GetNext(pos);
		if(cNode->timerTriggered) {
			//POSITION pos2 = cNode->ports.GetHeadPosition();
			//while(pos2) {
			//	CPortNode *pubPort = cNode->ports.GetNext(pos2);
//				fprintf(temp, "stating from timerTriggered %s rate %s\n", cNode->name,
//					GetNameFromRate(cNode->rate));
				theCEDG.DFSVisitAssignRates(cNode->index, cNode->rate);
			//}
		}
	}
//	fclose(temp);
}
#endif


void wdigraph::DFSVisitAssignRates(vertex u, rate_t rate) {
	set_color(u, GRAY);
//	fprintf(temp, "Setting %s to %s\n", get_node_name(u), GetNameFromRate(rate));
//	fflush(temp);

	set_rate(u, rate);
//	int weight = GetWeightFromRate(rate);
	edge e = firstout(u);
	int count = 0;
	while(e) {	
//		set_edge_wt(e, weight);
		vertex v = head(e);
		//If encounter GRAY or BLACK nodes, backtrack.
		if(WHITE == get_color(v)) {
			DFSVisitAssignRates(v, rate);
		}
		e = nextout(e);
		/*	count++;
		if(count > 100) {
			CString str;
			str.Format("Node %d %s edge %d, count %d", u, get_node_name(u), e, count);
			//AfxMessageBox(str);
		}
		*/
	}
	set_color(u, BLACK);
}



CString wdigraph::PrintCycleMsg(vertex u) {
	Node *n = DFSPath.find(u);
	ASSERT(n);
	CString cs;
	while(n) {
		cs = cs + "->" + get_node_name(n->x);
		n = DFSPath.get_next(n);
	}
	return cs;
}

bool wdigraph::IsGetMethodCall(edge e) {
	if(get_edge_type(e) == INVOCATION) {
		CString methodName = get_edge_name(e);
		if(methodName.GetLength() >= 3 && (methodName.Left(3) == "Get" ||
			methodName.Left(3) == "get")) {
			return true;
		}
	}
	return false;
}

bool wdigraph::IsBackwardMethodCallTriggeredByForwardEvent(edge e) {
	if(get_edge_type(e) == INVOCATION) {
		edge ereverse = edge_exists(head(e), tail(e));
		if(ereverse != -1 && get_edge_type(ereverse) == EVENT) {
			return true;
		} 
	}
	return false;
}
//Call reset_color() before calling this recursive function.
//Computes forward reachability graph (forward slice in Aladdin) from a component.
//We consider event trigger edges, method invocation edges except GetData method calls
//as forward edges, and GetData method calls as backward edges. Do not count them
//
void wdigraph::DFSForwardSlice(vertex u, FILE *f) {
	fprintf(f, "\"%s\"[style=filled];\n", get_node_name(u));
	set_color(u, GRAY);
	
	edge e = firstout(u);
	while(e) {
		if(!IsBackwardMethodCallTriggeredByForwardEvent(e)) {
		//if(!IsGetMethodCall(e)) {
		//if(get_edge_name(e) != INVOCATION) {
			vertex v = head(e);
			fprintf(f, "\"%s\" -> \"%s\"", get_node_name(u), get_node_name(v));
			//fprintf(f, "[label=%s, ", get_edge_name(e));
			if(get_edge_type(e) == REPLICATION || get_edge_type(e) == INVOCATION) {
				fprintf(f, "[style=dotted];\n");
			} else {
				fprintf(f, "[style=filled];\n");
			}

			if(get_color(v) == WHITE) {
				DFSForwardSlice(v, f);
			}
		} 
		e = nextout(e);
	}

	set_color(u, BLACK);
}

void wdigraph::DFSBackwardSlice(vertex u, FILE *f) {
	fprintf(f, "\"%s\"[style=filled];\n", get_node_name(u));
	set_color(u, GRAY);
	
	edge e = firstin(u);
	while(e) {
		if(!IsBackwardMethodCallTriggeredByForwardEvent(e)) {
		//if(!IsGetMethodCall(e)) {
		//if(get_edge_type(e) != INVOCATION) {
			vertex v = tail(e);
			fprintf(f, "\"%s\" -> \"%s\"", get_node_name(v), get_node_name(u));
			if(get_edge_type(e) == REPLICATION || get_edge_type(e) == INVOCATION) {
				fprintf(f, "[style=dotted];\n");
			} else {
				fprintf(f, "[style=filled];\n");
			}
			if(get_color(v) == WHITE) {
				DFSBackwardSlice(v, f);
			}
		}
		e = nextin(e);
	}

	set_color(u, BLACK);
}

int wdigraph::get_edge_wt(edge e) {
	return edges[e].wt;
}
void wdigraph::set_edge_wt(edge e, int wt) {
	edges[e].wt = wt;
}

edge_type_t wdigraph::get_edge_type(edge e) {
	return edges[e].type;
}

void wdigraph::set_edge_type(edge e, edge_type_t type) {
	edges[e].type = type;
}

CString wdigraph::get_edge_name(edge e) 
{return edges[e].name;}

void wdigraph::set_edge_name(edge e, const char *name) 
{edges[e].name = name;}

CPortNode *wdigraph::get_port_node(vertex v) 
{ASSERT(type == PEDG); 
return (CPortNode *)vertices[v].data;}

CComponentNode *wdigraph::get_comp_node(vertex v) 
{ ASSERT(type == CEDG ); 
return (CComponentNode *)vertices[v].data;}

CTaskNode *wdigraph::get_task_node(vertex v) 
{ASSERT(type == TASKGRAPH); 
return (CTaskNode *)vertices[v].data;}

void wdigraph::set_rate(vertex v, rate_t rate) 
{	ASSERT(type == PEDG || type == CEDG); 
if(type == PEDG) {
	CPortNode *pNode = (CPortNode *) vertices[v].data;
	pNode->rate = rate;
} else if(type == CEDG) {
	CComponentNode *cNode = (CComponentNode *) vertices[v].data;
	cNode->rate = rate;
}
}

////////////////////////////////////////////////////////////////////////
void CSystem::Cleanup() {
	//THis causes an error on opening a new file. So comment out for now.
	/*POSITION pos = compNodeList.GetHeadPosition();
	while(pos) {
		CComponentNode *cNode = compNodeList.GetNext(pos);
		delete cNode;
	}*/
	
	POSITION pos = processorNodeList.GetHeadPosition();
	while(pos) {
		CProcessorNode *pNode = processorNodeList.GetNext(pos);
		delete pNode;
	}
	compNodeList.RemoveAll();
	processorNodeList.RemoveAll();
	gTheSystem.thePEDG.reset();
	gTheSystem.theCEDG.reset();

	gEvtsNoSubscriberString.Empty();
	gPEDGCycleMsg.Empty();
	gUnreachableString.Empty();
/*
	if(backend && backend->IsOpen()) {
		backend->CloseWithUpdate();
	}
	delete backend;
	backend = NULL;
*/
};

void CSystem::Dump(const char *fileName) {
		FILE *f = fopen(fileName, "w");
		ASSERT(f);

		CString text;

		POSITION pos = gTheSystem.processorNodeList.GetHeadPosition();
		while(pos) {
			CProcessorNode *pNode = gTheSystem.processorNodeList.GetNext(pos);
			text += pNode->name;
			text += "\n";
			for(int i = 0; i < NUM_RATES; i++) {
				text += pNode->tasks[i].GetName();
				CString temp;
				temp.Format(" %2lf %2lf", pNode->tasks[i].wcet, pNode->tasks[i].wcrt);
				text += temp;
			}
		}
		POSITION pos2 = gTheSystem.compNodeList.GetHeadPosition();
		while(pos2) {
			CComponentNode *cNode = gTheSystem.compNodeList.GetNext(pos2);
			text += cNode->name;
			text += "\n\t[\n";
			POSITION pos3 = cNode->ports.GetHeadPosition();
			while(pos3) {
				CPortNode *pNode = cNode->ports.GetNext(pos3);
				text += "\t";
				switch(pNode->type) {
				case PUBLISHPORT:
					text += "PubPort";
					break;
				case SUBSCRIBEPORT:
					text += "SubPort";
					break;
				case FACET:
					text += "Facet";
					break;
				case RECEPTACLE:
					text += "Receptacle";
					break;
				}
				CString temp;
				temp.Format("%s  -- %lf", pNode->guid,  pNode->wcet);
				text += temp;
				text += "\n";
			}
			text += "\t]\n";
		}
		text += "]\n";

		fputs((const char*) text, f);
		fclose(f);
}

CComponentNode *CSystem::GetTimerCompNode(int period) {
	POSITION pos = compNodeList.GetHeadPosition();
	while(pos) {
		CComponentNode *cNode = compNodeList.GetNext(pos);
		if(cNode->isTimer) {
			int period1 = GetPeriodFromRate(cNode->rate);
			if(period1 == period)
				return cNode;
		}
	}
	return NULL;
}


void CSystem::AssignRates() {

	gTheSystem.AssignRatesToPEDG();
	gTheSystem.TimingAnalysis();

//	if(IDYES == AfxMessageBox("Would you like to update the AIF file with your changes?\
//The change will only take effect when you close the file.", MB_YESNO)) {
	
		
	CAvionicsDoc *pDoc = (CAvionicsDoc *) GetDocumentPtr();
	pDoc->TreeView->Populate();
	UpdateAIFWithRateAssignment(pDoc->backend);

//	}
}

//////////////////////////////////////////////////////////////////////////
void CSystem::ConstructTheSystem(const System& system) {
	gTheSystem.Cleanup();

	//Construct processorList and assign components to processors.
	set<Network> networks = system.Network_kind_children();
	for(set<Network>::iterator ii = networks.begin(); ii != networks.end(); ii++) {
		set<Processor> procs = Network::Cast(*ii).Processor_kind_children();
		int size = procs.size();
		for(set<Processor>::iterator ii2 = procs.begin(); ii2 != procs.end(); ii2++) {
			Processor proc = *ii2;
			CProcessorNode *processorNode = new CProcessorNode(string(proc.name()).c_str(),
				CString(string(proc.guid()).c_str()));
			gTheSystem.processorNodeList.AddTail(processorNode);
/////Construct all the component instance and ports.
			set<ComponentInstance> comps = proc.ComponentInstance_kind_children();
			for(set<ComponentInstance>::iterator iComp = comps.begin(); iComp != comps.end(); iComp++) {
				ComponentInstance appComp = ComponentInstance::Cast(*iComp);
				CString guidComp = CString(string(appComp.guid()).c_str());
				CString name(string(appComp.name()).c_str());
				component_type_t type = MASTER;
				if(iComp->type() == SupportComponent::meta) {
				//	name += "_Proxy";
					type = PROXY;
				}
				__int64 itemid = appComp.itemID();
				__int64 groupid = appComp.groupID();

				CComponentNode *cNode = new CComponentNode(name, type, guidComp, (int)itemid, (int)groupid);

				cNode->locked = appComp.locked();
				gTheSystem.compNodeList.AddTail(cNode);
				processorNode->AddComponent(cNode);
				
				gTheSystem.theCEDG.vertices[++gTheSystem.theCEDG.n].data = (DWORD) cNode;
				cNode->index = gTheSystem.theCEDG.n;

				set<PublishPort> pubPorts = appComp.PublishPort_kind_children();
				for(set<PublishPort>::iterator iPort = pubPorts.begin(); iPort != pubPorts.end(); iPort++) {
					PublishPort pubPort = *iPort;
					CString guidPort = CString(string(iPort->guid()).c_str());
					CString name = string(iPort->name()).c_str();
					//bool asynchronous = iPort->asynchronous();
					CPortNode *portNode = new CPortNode(PUBLISHPORT, guidPort, name);
					//These 2 attributes dont make sense for publishports.
					//portNode->asynchronous = iPort->asynchronous();
					//portNode->correlation = iPort->correlation();
					cNode->AddPort(portNode);
					PortNodeMap.SetAt(string(iPort->guid()).c_str(), portNode);
					
					gTheSystem.thePEDG.vertices[++gTheSystem.thePEDG.n].data = (DWORD) portNode;
					portNode->index = gTheSystem.thePEDG.n;
				}

				set<SubscribePort> subPorts =  appComp.SubscribePort_kind_children();
				for(set<SubscribePort>::iterator iPort2 = subPorts.begin(); iPort2 != subPorts.end(); iPort2++) {
					SubscribePort subPort = *iPort2;
					CString guidPort = CString(string(iPort2->guid()).c_str());
					CString name = string(iPort2->name()).c_str();
					CPortNode *portNode = new CPortNode(SUBSCRIBEPORT, guidPort, name);
					portNode->asynchronous = iPort2->asynchronous();
					portNode->correlation = iPort2->correlation();
					cNode->AddPort(portNode);
					PortNodeMap.SetAt(string(iPort2->guid()).c_str(), portNode);
					
					gTheSystem.thePEDG.vertices[++gTheSystem.thePEDG.n].data = (DWORD) portNode;
					portNode->index = gTheSystem.thePEDG.n;
					//This doesnt work! subPorts is a copy of the original, so pointer goes out
					//of scope.
					//SubPortPtrMap.SetAt(string(iPort2->guid()).c_str(), (SubscribePort *) &(*iPort2));
				}
				
				set<Facet> facets = appComp.Facet_kind_children();
				for(set<Facet>::iterator iFacet = facets.begin(); iFacet != facets.end(); iFacet++) {
					CString guidFacet = CString(string(iFacet->guid()).c_str());
					CString name = string(iFacet->name()).c_str();
					CPortNode *portNode = new CPortNode(FACET, guidFacet, name);
					cNode->AddPort(portNode);
					PortNodeMap.SetAt(string(iFacet->guid()).c_str(), portNode);

					gTheSystem.thePEDG.vertices[++gTheSystem.thePEDG.n].data = (DWORD) portNode;
					portNode->index = gTheSystem.thePEDG.n;
				}

				set<Receptacle> receptacles =  appComp.Receptacle_kind_children();
				for(set<Receptacle>::iterator iRecep = receptacles.begin(); iRecep != receptacles.end(); iRecep++) {
					CString guidRecep = CString(string(iRecep->guid()).c_str());
					CString name = string(iRecep->name()).c_str();
					CPortNode *portNode = new CPortNode(RECEPTACLE, guidRecep, name);
					cNode->AddPort(portNode);
					PortNodeMap.SetAt(string(iRecep->guid()).c_str(), portNode);

					gTheSystem.thePEDG.vertices[++gTheSystem.thePEDG.n].data = (DWORD) portNode;
					portNode->index = gTheSystem.thePEDG.n;
				}
			} //end of for(set<ComponentInstance>::

//////////////////////////////////////////////////////////////////////
			set<Process> processes = proc.Process_kind_children();
			for(set<Process>::iterator ii3 = processes.begin(); ii3 != processes.end(); ii3++) {
				Process process = *ii3;
				set<Thread> threads = process.Thread_kind_children();
				for(set<Thread>::iterator ii5 = threads.begin(); ii5 != threads.end(); ii5++) {
					Thread thr = Thread::Cast(*ii5);
					CString name = string(thr.name()).c_str();
					rate_t rate = GetRateFromName(name);
					CTaskNode * tNode = processorNode->GetTaskFromRate(rate);
				
					set<TriggerQoSProperties> tQoSProps = thr.tQoSProp();
					for(set<TriggerQoSProperties>::iterator ii6 = tQoSProps.begin(); ii6 != tQoSProps.end(); ii6++) {
						SubscribePort subPort = ii6->trigger_end();
						CString guidPort = CString(string(subPort.guid()).c_str());
						CPortNode *pNode = gTheSystem.FindPortNodeByGUID(guidPort);
						pNode->rate = rate;
						tNode->AddPort(pNode);
					}
				}
			}//end of for(set<Process>
		//break; //HACK: for RTSS Demo
		} //end of for(set<Processor>
	}//End of for(set<Network>
	
	//2nd pass, wire up the vertices in PEDG and CEDG.
	set<Interactions> interactions = system.Interactions_kind_children();
	for(set<Interactions>::iterator iInter = interactions.begin(); iInter != interactions.end(); iInter++)
	{
		Interactions interactions = *iInter;
		set<ComponentInstance> comps = interactions.componentInstances();
		set<TimerComponent> timerComps = interactions.TimerComponent_children();

		//Loop thru all TimerComponent, and assign the timerTriggered attribute for each component
		//triggered by a timer.
		for(set<TimerComponent>::iterator timerCompIter = timerComps.begin(); timerCompIter != timerComps.end();
				timerCompIter++) {
			TimerComponent timerComp = TimerComponent::Cast(*timerCompIter);
			///////////////////////////////////////////////////////////////////
			//Create artificial components for timers to facilitate assigning rates by traversing PEDG.
			CString guid = CString(string(timerComp.guid()).c_str());
			int period = atoi(string(timerComp.period()).c_str());
			if(period == 0) { 
				CString cs;
				cs.Format("Error: The timer with GUID %s has period == 0. Please go to the model and assign a period.", guid); 
				AfxMessageBox(cs);
				return;
			}
			ASSERT(period);
			//Unlike regular components, a timer may be duplicated for syntactical reasons.
			//only create one timerComp for each rate.
			CComponentNode *timerNode = gTheSystem.GetTimerCompNode(period);
			CPortNode *portNode = NULL;
			if(!timerNode) {
				CString name;
				//In order to make timer names unique on a processor, append timer period to
				//"Timer" as its name.
				//name.Format("%s_%dms", string(timerComp.name()).c_str(), period);
				name.Format("%s", string(timerComp.name()).c_str());
				CString guidComp = CString(string(timerComp.guid()).c_str());
				timerNode = new CComponentNode(name, MASTER, guidComp, 0, 0);
				timerNode->isTimer = true;
				timerNode->rate = GetRateFromPeriod(period);
				gTheSystem.compNodeList.AddTail(timerNode);

				portNode = new CPortNode(PUBLISHPORT, CString(""), name);
				portNode->isTimer = true;
				timerNode->AddPort(portNode);
				portNode->rate = GetRateFromPeriod(period);
				portNode->wcet = 0.0;
				//Add the componentnode to system compnodelist, but not to processor's compnodelist.
				//for traversal of PEDG
				
				gTheSystem.theCEDG.vertices[++gTheSystem.theCEDG.n].data = (DWORD) timerNode;
				timerNode->index = gTheSystem.theCEDG.n;
							
				gTheSystem.thePEDG.vertices[++gTheSystem.thePEDG.n].data = (DWORD) portNode;	
				portNode->index = gTheSystem.thePEDG.n; 
			} else {
				POSITION pos = timerNode->ports.GetHeadPosition();
				while(pos) {
					portNode = timerNode->ports.GetNext(pos);
					break;
				}
				ASSERT(portNode);
			}
			///////////////////////////////////////////////////////////////////
			set<Event> events = timerComp.event();
			for(set<Event>::iterator iEvent = events.begin(); iEvent != events.end(); iEvent++) {
				set<SubscribePort> subPorts = iEvent->dst();
				if(subPorts.size() == 0) {
					CString temp;
					temp.Format("Component: %s; Event: %s\r\n", string(timerComp.name()).c_str(), string(iEvent->name()).c_str());
					gEvtsNoSubscriberString += temp;
				}
				for(set<SubscribePort>::iterator iPort2 = subPorts.begin(); iPort2 != subPorts.end(); iPort2++) {
					CString guidPort = CString(string(iPort2->guid()).c_str());
					CPortNode *subPort = gTheSystem.FindPortNodeByGUID(guidPort);
					int period = atoi(string(timerComp.period()).c_str());
					subPort->rate = GetRateFromPeriod(period);
					subPort->timerTriggered = true;
					subPort->parentComp->timerTriggered = true;
					subPort->parentComp->rate = GetRateFromPeriod(period);
					////////////////////////////////////////////////////////////
					//Create artificial components for timers to facilitate assigning rates by traversing PEDG.
					//Do not wire up CEDG this is done later based on PEDG.
					//edge ec = gTheSystem.theCEDG.join(cNode->index, subPort->parentComp->index);
					//gTheSystem.theCEDG.set_edge_name(ec, "Timer Event");
					//gTheSystem.theCEDG.set_edge_type(ec, EVENT);
					edge ep = gTheSystem.thePEDG.join(portNode->index, subPort->index);
					gTheSystem.thePEDG.set_edge_name(ep, string(iEvent->name()).c_str());
					gTheSystem.thePEDG.set_edge_type(ep, EVENT);
					////////////////////////////////////////////////////////////
					//If a component gets triggered by a timer, add the timer to the same processor
					//No, timers shouldnt belong to any processor. they are virtual components
					//that denotes triggers to regular components.
					/*
					CProcessorNode *processorNode = subPort->parentComp->processor;
					ASSERT(processorNode);
					if(!processorNode->ContainsComponent(timerNode)) {	
						processorNode->AddComponent(timerNode);	
					}*/
				}
			}
		}

		//1st pass, deal with event dependencies. edge name is event name.
		for(set<ComponentInstance>::iterator iComp = comps.begin(); iComp != comps.end(); iComp++) {
			ComponentInstance appComp = ComponentInstance::Cast(*iComp);
			CString guidComp = CString(string(appComp.guid()).c_str());
			CComponentNode *cNode = gTheSystem.FindCompNodeByGUID(guidComp);

			//Add bidirectional edges from master component to proxy components.
			if(iComp->type() == SupportComponent::meta) {
				SupportComponent supComp = SupportComponent::Cast(*iComp);
				ApplicationComponent master = supComp.master();
				ASSERT(master);
				CString guid = CString(string(master.guid()).c_str());
				CComponentNode *masterComp = gTheSystem.FindCompNodeByGUID(guid);
				edge ep = gTheSystem.theCEDG.join(masterComp->index, cNode->index);
				gTheSystem.theCEDG.set_edge_name(ep, "Replication");
				gTheSystem.theCEDG.set_edge_type(ep, REPLICATION);

				//This creates cycles in CEDG, so take out for now.
				//edge ep2 = gTheSystem.theCEDG.join(cNode->index, masterComp->index);
				//gTheSystem.theCEDG.set_edge_name(ep2, "Replication");
				//gTheSystem.theCEDG.set_edge_type(ep2, REPLICATION);

				//HACK: Add equivalence edges between master and proxy component ports
				//based on names. note this relation is bidirectional. 
				//this is a hack due to lack of better correlation
				//in the model
				SetMasterProxyPortConnections(&master, &supComp);
			}

			//Construct inter-component dependencies for event triggers. edge name is name of event published/subscribed to
			set<PublishPort> pubPorts =  appComp.PublishPort_kind_children();
			for(set<PublishPort>::iterator iPort = pubPorts.begin(); iPort != pubPorts.end(); iPort++) {
				CString guid = CString(string(iPort->guid()).c_str());
				CPortNode *pubPort = gTheSystem.FindPortNodeByGUID(guid);
				set<Event> events = iPort->event();
				ProcessPEDGSuccessors(pubPort, events);
			}

			//Construct inter-component dependencies for invocations.
			set<Receptacle> receps =  appComp.Receptacle_kind_children();
			for(set<Receptacle>::iterator iRecep = receps.begin(); iRecep != receps.end(); iRecep++) {
				Receptacle recep = *iRecep;
				
				CString guid = CString(string(iRecep->guid()).c_str());
				CPortNode *recepPort = gTheSystem.FindPortNodeByGUID(guid);
				set<InvocationConnection> invconns = iRecep->invokes();
				for(set<InvocationConnection>::iterator ii = invconns.begin(); ii != invconns.end(); ii++) {
					InvocationConnection invconn = *ii;
					Facet facet = invconn.invokes_end();
					if(facet) {
						CString methodName = GetInvocationMethodName(&recep);
						CString guidFacet = CString(string(facet.guid()).c_str());
						CPortNode *facetPort = gTheSystem.FindPortNodeByGUID(guidFacet);
						edge ep = gTheSystem.thePEDG.join(recepPort->index, facetPort->index);
						gTheSystem.thePEDG.set_edge_name(ep, methodName);
						gTheSystem.thePEDG.set_edge_type(ep, INVOCATION);
					}
				}
			}

			//Construct intra-component dependencies. edge name is "internal"
			set<SubscribePort> subPorts =  appComp.SubscribePort_kind_children();
			for(set<SubscribePort>::iterator iPort2 = subPorts.begin(); iPort2 != subPorts.end(); iPort2++) {
				CString guid = CString(string(iPort2->guid()).c_str());
				CPortNode *subPortNode = gTheSystem.FindPortNodeByGUID(guid);

				//An subscribe port can either trigger an action which triggers a pub port, or
				//it can trigger an action which goes to method, which belong to a receptacle
				//Subport -> Pubport
				set<TriggerQoSProperties> tqps = iPort2->action();
				for(set<TriggerQoSProperties>::iterator itqp = tqps.begin(); itqp != tqps.end(); itqp++) {
					Action action = itqp->action_end();
					//SAM: assume the input wcet is in us, convert to ms.
					//HACK: do not convert
					subPortNode->wcet = atof(string(action.WCET()).c_str());
					//subPortNode->wcet = atof(string(action.WCET()).c_str())/1000.0;
					//cNode->wcet += atof(string(action.WCET()).c_str());
					set<PublishPort> pubPorts = action.port();
					for(set<PublishPort>::iterator iter = pubPorts.begin(); iter != pubPorts.end(); iter++) {
						CString guidPort = CString(string(iter->guid()).c_str());
						CPortNode *pubPortNode = gTheSystem.FindPortNodeByGUID(guidPort);
						edge ep = gTheSystem.thePEDG.join(subPortNode->index, pubPortNode->index);
						gTheSystem.thePEDG.set_edge_name(ep, "internal");
						gTheSystem.thePEDG.set_edge_type(ep, INTERNAL);
					}
		
					//Possible subport->receptacle internal connections, say EARTHMODEL.
					set<CallOut> callouts = action.co();
					for(set<CallOut>::iterator ii = callouts.begin(); ii != callouts.end(); ii++) {
						CallOut co = *ii;
						Receptacle recep = co.receptacle();
						CString guidPort = CString(string(recep.guid()).c_str());
						CPortNode *pNode = gTheSystem.FindPortNodeByGUID(guidPort);
						edge ep = gTheSystem.thePEDG.join(subPortNode->index, pNode->index);
						gTheSystem.thePEDG.set_edge_name(ep, "Internal");
						gTheSystem.thePEDG.set_edge_type(ep, INTERNAL);
					}
				}
			}
			//Facet -> Action -> pubport
			set<Facet> facets = appComp.Facet_kind_children();
			for(set<Facet>::iterator iFacet = facets.begin(); iFacet != facets.end(); iFacet++) {
				Facet facet = *iFacet;
				CString guidFacet = CString(string(facet.guid()).c_str());
				CPortNode *facetNode = gTheSystem.FindPortNodeByGUID(guidFacet);

				set<InvocationQoSProperties> iqps = facet.iqos();

				for(set<InvocationQoSProperties>::iterator ii = iqps.begin(); ii != iqps.end(); ii++) {
					InvocationQoSProperties iqp = *ii;
					Action action = iqp.action();
					facetNode->wcet = atof(string(action.WCET()).c_str());
					//cNode->wcet += atof(string(action.WCET()).c_str());
					set<PublishPort> pubPorts = action.port();
					for(set<PublishPort>::iterator iter = pubPorts.begin(); iter != pubPorts.end(); iter++) {
						CString guidPort = CString(string(iter->guid()).c_str());
						CPortNode *pubPortNode = gTheSystem.FindPortNodeByGUID(guidPort);
						edge ep = gTheSystem.thePEDG.join(facetNode->index, pubPortNode->index);
						gTheSystem.thePEDG.set_edge_name(ep, "Internal");
						gTheSystem.thePEDG.set_edge_type(ep, INTERNAL);
					}
		
					//Facet -> Action -> Receptacle
					set<CallOut> callouts = action.co();
					for(set<CallOut>::iterator ii = callouts.begin(); ii != callouts.end(); ii++) {
						CallOut co = *ii;
						Receptacle recep = co.receptacle();
						CString guidPort = CString(string(recep.guid()).c_str());
						CPortNode *pNode = gTheSystem.FindPortNodeByGUID(guidPort);
						edge ep = gTheSystem.thePEDG.join(facetNode->index, pNode->index);
						gTheSystem.thePEDG.set_edge_name(ep, "Internal");
						gTheSystem.thePEDG.set_edge_type(ep, INTERNAL);
					}
				}
			}
		}
		//end of for(set<ComponentInstance>::iterator iComp = comps.begin(); iComp != comps.end(); iComp++) 
	} //end of for(iInter = interactions.begin(); iInter != interactions.end(); iInter++)

	//First construct event edges in CEDG based on publishport to subscribeport connections.
	POSITION pos = gTheSystem.compNodeList.GetHeadPosition();
	while(pos) {
		CComponentNode *cNode = gTheSystem.compNodeList.GetNext(pos);
		POSITION pos2 = cNode->ports.GetHeadPosition();
		while(pos2) {
			CPortNode *pNode = cNode->ports.GetNext(pos2);
			if(pNode->type == PUBLISHPORT) {
				edge e = gTheSystem.thePEDG.firstout(pNode->index);
				while(e) {
					vertex v = gTheSystem.thePEDG.head(e);
					CPortNode *pNode2 = gTheSystem.thePEDG.get_port_node(v);
					edge ec = gTheSystem.theCEDG.join(pNode->parentComp->index, pNode2->parentComp->index);
					gTheSystem.theCEDG.set_edge_name(ec, gTheSystem.thePEDG.get_edge_name(e));
					gTheSystem.theCEDG.set_edge_type(ec, EVENT);
					e = gTheSystem.thePEDG.nextout(e);
				}
			}
		}
	}
	
	//Next construct invocation edges in CEDG based on receptacle to facet connections
	POSITION pos11 = gTheSystem.compNodeList.GetHeadPosition();
	while(pos11) {
		CComponentNode *cNode = gTheSystem.compNodeList.GetNext(pos11);
		POSITION pos2 = cNode->ports.GetHeadPosition();
		while(pos2) {
			CPortNode *pNode = cNode->ports.GetNext(pos2);
			if(pNode->type == RECEPTACLE) {
				edge e = gTheSystem.thePEDG.firstout(pNode->index);
				while(e) {
					vertex v = gTheSystem.thePEDG.head(e);
					CPortNode *pNode2 = gTheSystem.thePEDG.get_port_node(v);
					//if(!gTheSystem.theCEDG.edge_exists(pNode2->parentComp->index, pNode->parentComp->index)) {
					edge ec = gTheSystem.theCEDG.join(pNode->parentComp->index, pNode2->parentComp->index);
					//}
					gTheSystem.theCEDG.set_edge_name(ec, gTheSystem.thePEDG.get_edge_name(e));
					gTheSystem.theCEDG.set_edge_type(ec, INVOCATION);
					e = gTheSystem.thePEDG.nextout(e);
				}
			}
		}
	}
	AssignRates(); //HACK RTSS

} //end of void ConstructTheSystem(const System& system) {

//HACK:  establish link from master component's subscribe ports to proxy component's
//subscribe ports, so that all event triggers from master components gets propogated through
//to proxy components.
void CSystem::SetMasterProxyPortConnections(ApplicationComponent *masterComp, SupportComponent *proxyComp) {
	set<SubscribePort> ports =  masterComp->SubscribePort_kind_children();
	set<SubscribePort> portsProxy =  proxyComp->SubscribePort_kind_children();
	for(set<SubscribePort>::iterator iPort = ports.begin(); iPort != ports.end(); iPort++) {
		CString guid(string(iPort->guid()).c_str());
		CPortNode *portNode = FindPortNodeByGUID(guid);
	
		for(set<SubscribePort>::iterator iPort2 = portsProxy.begin(); iPort2 != portsProxy.end(); iPort2++) {
			CString guid2(string(iPort2->guid()).c_str());
			CPortNode *portNode2 = FindPortNodeByGUID(guid2);
			edge e1 = thePEDG.join(portNode->index, portNode2->index);
			thePEDG.set_edge_name(e1, "Replication");
			thePEDG.set_edge_type(e1, REPLICATION);
		}
	}
}

void CSystem::ConstructBFSSortedList()
{
	theCEDG.BFSSortedNodes.remove_all();
	theCEDG.reset_color();
	POSITION pos = compNodeList.GetHeadPosition();
	while(pos) {
		CComponentNode *cNode = compNodeList.GetNext(pos);
		if(cNode->isTimer) {
			theCEDG.BFSVisit(cNode->index);
		}
	}
	//For components unreachable from BFS search, i.e., color is WHITE,
	//append them to BFSSortedNodes list.
	pos = compNodeList.GetHeadPosition();
	while(pos) {
		CComponentNode *cNode = compNodeList.GetNext(pos);
		if(!cNode->isTimer && theCEDG.get_color(cNode->index) == WHITE) {
			theCEDG.BFSSortedNodes.add(cNode->index);
		}
	} 
}
	
void CSystem::TimingAnalysis() {	
	//////////////////////////////////////////////////////////////////////////
	//First calculate task WCETs. For tasks with WCET = 0, pretend they dont
	//exist. do not display or use them in RMA.
	//TODO: Remove first

	POSITION pos = processorNodeList.GetHeadPosition();
	while(pos) {
		CProcessorNode *pNode = processorNodeList.GetNext(pos);
		pNode->CalculateTaskWCET();
	}

	//Simple RMA equations for CTaskNode::wcrt calculation.
	pos = processorNodeList.GetHeadPosition();
	while(pos) {
		CProcessorNode *pNode = processorNodeList.GetNext(pos);
		pNode->RMAnalysis();
	}

	//Construct task graph. look thru the PUBLISHPORTs of each task, trace
	//PEDG to the SUBSCRIBEPORTs that receive events from PUBPORTs,and get their
	//parentTask attribute. If it's a different task, then add an edge in the task graph.
	//Wire up the vertices.

	pos = processorNodeList.GetHeadPosition();
	while(pos) {
		CProcessorNode *pNode = processorNodeList.GetNext(pos);
		//Construct the vertices in the task graph.
		for(int i = 0; i < NUM_RATES; i++) {
			CTaskNode *tNode = &pNode->tasks[i];
			if(tNode->ports.GetCount() == 0) continue;
			theTG.vertices[++theTG.n].data = (DWORD) tNode;
			tNode->index = theTG.n;
		}
	}

	
	pos = processorNodeList.GetHeadPosition();
	while(pos) {
		CProcessorNode *pNode = processorNodeList.GetNext(pos);
		for(int i = 0; i < NUM_RATES; i++) {
			CTaskNode *tNode = &pNode->tasks[i];
			if(tNode->ports.GetCount() == 0) continue;
			POSITION pos2 = tNode->ports.GetHeadPosition();
			while(pos2) {
				CPortNode *portNode = tNode->ports.GetNext(pos2);
				
				if(portNode->type == SUBSCRIBEPORT || portNode->type == FACET) {
					edge e = thePEDG.firstin(portNode->index);
					while(e) {
						CPortNode *portNode2 = thePEDG.get_port_node(thePEDG.tail(e));
						CTaskNode *tNode2 = portNode2->parentTask;
						if(tNode2 != NULL && tNode != tNode2 && tNode->parentProcessor != tNode2->parentProcessor) {
							theTG.join(tNode2->index, tNode->index);
						}
						e = thePEDG.nextin(e);
					}
				}
			}
		}
	}
}


//add all inter-component edges, both in the PEDG and CEDG.
void ProcessPEDGSuccessors(CPortNode *pubPort, set<Event> &events) {
	for(set<Event>::iterator iEvent = events.begin(); iEvent != events.end(); iEvent++) {
		set<SubscribePort> subPorts = iEvent->dst();
		if(subPorts.size() == 0) {
			CString temp;
			temp.Format("Component: %s; Event: %s\r\n", pubPort->parentComp->name + "." + pubPort->GetName(), string(iEvent->name()).c_str());
			gEvtsNoSubscriberString += temp;
		}

		for(set<SubscribePort>::iterator iPort2 = subPorts.begin(); iPort2 != subPorts.end(); iPort2++) {
			CString guidPort = CString(string(iPort2->guid()).c_str());
			CPortNode *subPort = gTheSystem.FindPortNodeByGUID(guidPort);
			edge ep = gTheSystem.thePEDG.join(pubPort->index, subPort->index);
			//edge ec = gTheSystem.theCEDG.join(pubPort->parentComp->index, subPort->parentComp->index);
			gTheSystem.thePEDG.set_edge_name(ep, string(iEvent->name()).c_str());
			gTheSystem.thePEDG.set_edge_type(ep, EVENT);
//			gTheSystem.theCEDG.set_edge_name(ec, string(iEvent->name()).c_str());
//			gTheSystem.theCEDG.set_edge_type(ec, EVENT);
		}
	}
}

CPortNode *CSystem::FindPortNodeByGUID(CString &guidPort) {
	CPortNode *pNode = NULL;
	BOOL ret = PortNodeMap.Lookup(guidPort, pNode);
	ASSERT(ret && pNode);
	return pNode;
#if 0
	POSITION pos = compNodeList.GetHeadPosition();
	while(pos) {
		CComponentNode *compNode = compNodeList.GetNext(pos);
		POSITION pos2 = compNode->ports.GetHeadPosition();
		while(pos2) {
			CPortNode *pNode = compNode->ports.GetNext(pos2);
			if(pNode->guid == guidPort)
				return pNode;
		}
	}
	CString cs;
	cs.Format("The port with guid %s is not found!", guidPort);
	AfxMessageBox(cs);
	return NULL;
#endif 
}

CComponentNode *CSystem::FindCompNodeByGUID(CString &guidComp) {
	POSITION pos = compNodeList.GetHeadPosition();
	while(pos) {
		CComponentNode *compNode = compNodeList.GetNext(pos);
		if(compNode->guid == guidComp) { 
			return compNode;
		}
	}
	CString cs;
	cs.Format("The CompNode with guid %s is not found!", guidComp);
	AfxMessageBox(cs);
	return NULL;
}

CProcessorNode *CSystem::FindProcessorNodeByGUID(CString &guidComp) {
	POSITION pos = processorNodeList.GetHeadPosition();
	while(pos) {
		CProcessorNode *pNode = processorNodeList.GetNext(pos);
		if(pNode->guid == guidComp) { 
			return pNode;
		}
	}
	ASSERT(false);
	CString cs;
	cs.Format("The ProcessorNode with guid %s is not found!", guidComp);
	AfxMessageBox(cs);
	return NULL;
}

CString CTaskNode::GetName() {
		CString taskName;
		switch(rate) {
		case UNASSIGNED:
			 taskName = "UNASSIGNED";
			 break;
		case HZ1:
			taskName = "T_1Hz";
			break;
		case HZ5:
			taskName = "T_5Hz";
			break;
		case HZ10:
			taskName = "T_10Hz";
			break;
		case HZ20:
			taskName = "T_20Hz";
			break;
		case HZ40:
			taskName = "T_40Hz";
			break;
		}
		return taskName;
}

CTaskNode *CProcessorNode::GetTaskFromRate(rate_t rate) {
	switch(rate) {
		case UNASSIGNED:
			ASSERT(false);
			return NULL;
		case HZ1:
			return &tasks[0];
		case HZ5:
			return &tasks[1];
		case HZ10:
			return &tasks[2];
		case HZ20:
			return &tasks[3];
		case HZ40:
			return &tasks[4];
		}
	ASSERT(false);
	return NULL;
}

//void CProcessorNode::AddComponent




double CProcessorNode::GetUtilization() {
	double util = 0.0;
	for(int i = 0; i < NUM_RATES; i++) {
		if(tasks[i].wcet != 0.0) {
			util += tasks[i].wcet/tasks[i].GetPeriod();
		}
	}
	return util;
}

double CProcessorNode::GetUtilBound() {
	int numTasks = GetNumTasks();
	if(numTasks == 0) 
		return 1.00;
	else
		return numTasks * (pow(2.0, 1.0/numTasks) - 1);
}

int CProcessorNode::GetNumTasks() {
	int numTasks = 0;
	for(int i = 0; i < NUM_RATES; i++) {
		if(tasks[i].ports.GetCount() > 0) {
			numTasks++;
		}
	}
	return numTasks;
}

bool CProcessorNode::isSchedulable() {
	for(int i = 0; i < NUM_RATES; i++) {
		if(tasks[i].wcet != 0.0) {
			if(tasks[i].wcrt > tasks[i].GetPeriod()) {
				return false;
			}
		}
	}
	return true;
}

//Just grab all the ports in the components contained in the task
//and add up the WCETs.
void CProcessorNode::CalculateTaskWCET() {
	//First clean up the task list.
	for(int i = 0; i < 5; i++) {
		tasks[i].wcet = 0.0;
		tasks[i].ports.RemoveAll();
	}

	//Then add ports to tasks based on rate assignment to ports.
	POSITION pos = components.GetHeadPosition();
	int count1 = components.GetCount();
	while(pos) {
		CComponentNode *cNode = components.GetNext(pos);
		POSITION pos2 = cNode->ports.GetHeadPosition();
		int count2 = cNode->ports.GetCount();
		while(pos2) {
			CPortNode *pNode = cNode->ports.GetNext(pos2);
			//if(pNode->type == SUBSCRIBEPORT) {
			//	cNode->util += pNode->wcet / GetPeriodFromRate(pNode->rate);
			//}
			//if(!(pNode->type == SUBSCRIBEPORT || pNode->type == FACET  ))  continue;
			//Do not count Facets. only subscribe ports can belong to a task
			//as per ESML definition.
			//if(!(pNode->type == SUBSCRIBEPORT))  continue;
			switch(pNode->rate) {
			case UNASSIGNED:
				break;
			case HZ1:
				tasks[0].AddPort(pNode);
				if(pNode->type == SUBSCRIBEPORT)
					tasks[0].wcet += pNode->wcet;
				break;
			case HZ5:
				tasks[1].AddPort(pNode);
				if(pNode->type == SUBSCRIBEPORT)
					tasks[1].wcet += pNode->wcet;
				break;
			case HZ10:
				tasks[2].AddPort(pNode);
				if(pNode->type == SUBSCRIBEPORT)
					tasks[2].wcet += pNode->wcet;
				break;
			case HZ20:
				tasks[3].AddPort(pNode);
				if(pNode->type == SUBSCRIBEPORT)
					tasks[3].wcet += pNode->wcet;
				break;
			case HZ40:
				tasks[4].AddPort(pNode);
				if(pNode->type == SUBSCRIBEPORT)
					tasks[4].wcet += pNode->wcet;
				break;
			}
		}
	}
}

//Hack: doesnt matter if time unit is us or ms, i got you covered.
rate_t GetRateFromPeriod(int period) {
	switch (period) {
	case 1000:
	case 1000000:
		return HZ1;
	case 200:
	case 200000:
		return HZ5;
	case 100:
	case 100000:
		return HZ10;
	case 50:
	case 50000:
		return HZ20;
	case 25:
	case 25000:
		return HZ40;
	default:
		return UNASSIGNED;
	}
}

//This relies on a strict naming convention for thread names.
rate_t GetRateFromName(CString name) {
  //  CString name = name1.Left(6);
	name.TrimLeft();
	name.TrimRight();
	if(name.Left(3) == "1Hz" || name.Left(3) == "1HZ" || name.Left(4) == "1 Hz" || name.Left(4) == "1 HZ") 
		return HZ1;
	else if(name.Left(3) == "5Hz" || name.Left(3) == "5HZ" || name.Left(4) == "5 Hz" || name.Left(4) == "5 HZ") 
		return HZ5;
	else if(name.Left(4) == "10Hz" || name.Left(4) == "10HZ" || name.Left(5) == "10 Hz" || name.Left(5) == "10 HZ") 
		return HZ10;
	else if(name.Left(4) == "20Hz" || name.Left(4) == "20HZ" || name.Left(5) == "20 Hz" || name.Left(5)== "20 HZ") 
		return HZ20;
	else if(name.Left(4) == "40Hz" || name.Left(4) =="40HZ" || name.Left(5) == "40 Hz" || name.Left(5) =="40 HZ") 
		return HZ40;
	else {
		ASSERT(false);
		return UNASSIGNED;
	}
	
}

CString GetNameFromRate(rate_t rate) {
	switch(rate) {
	case HZ1:
		return "1HZ";
	case HZ5:
		return "5HZ";
	case HZ10:
		return "10HZ";
	case HZ20:
		return "20HZ";
	case HZ40:
		return "40HZ";
	default:
		return "UNASSIGNED";
	}
}

int GetPeriodFromRate(rate_t rate) {
	switch(rate) {
	case HZ1:
		return 1000000;
	case HZ5:
		return 200000;
	case HZ10:
		return 100000;
	case HZ20:
		return 50000;
	case HZ40:
		return 25000;
	default:
		return 1000000000;
	}
}
/*
int GetWeightFromRate(rate_t rate) {
	switch(rate) {
	case HZ1:
		return 1;
	case HZ5:
		return 5;
	case HZ10:
		return 10;
	case HZ20:
		return 20;
	case HZ40:
		return 40;
	default:
		return 1000000;
	}
}
*/
CString GetTypeNameFromType(port_type_t type1) {
	CString type;
	switch(type1) {
	case PUBLISHPORT:
		type = "Pub Port";
		break;
	case SUBSCRIBEPORT:
		type = "Sub Port";
		break;
	case FACET:
		type = "Facet";
		break;
	case RECEPTACLE:
		type = "Receptacle";
		break;
	default:
		ASSERT(false);
	}
	return type;
}

CString GetEdgeNameFromType(edge_type_t type1) {
	CString type;
	switch(type1) {
	case EVENT:
		 return "Event";
	case INVOCATION:
		return "Invocation";
	case INTERNAL:
		return "Internal";
	case REPLICATION:
		return "Replication";
	default:
		ASSERT(false);
		return "InvalidType";
	}
}


int CTaskNode::GetPeriod() {
	return GetPeriodFromRate(rate);
}

bool CTaskNode::ContainsPort(const CPortNode *Port) {
	POSITION pos = ports.GetHeadPosition();
	while(pos) {
		CPortNode *pNode = ports.GetNext(pos);
		if(pNode == Port) {
			return true;
		}
	}
	return false;
}

//Assume rate monotonic priority assignment.
double CProcessorNode::Interference(const CTaskNode *tNode, double responseTime) {
	double sum = 0;
	int myperiod = GetPeriodFromRate(tNode->rate);
	for(int i = 0; i < NUM_RATES; i++) {
		int hisperiod = GetPeriodFromRate(tasks[i].rate);
		if(hisperiod < myperiod) {
			sum += ceil(responseTime/hisperiod) * (tasks[i].wcet +
				2 * cxtSwitchTime);
		}
	}
	return sum;
}


void CProcessorNode::RMAnalysis() {
	for(int i = 0; i < NUM_RATES; i++) {
		CTaskNode *task = &tasks[i];
		if(task->ports.GetCount() == 0) continue;
		double oldr = 0.0, r = 0.0;
		r = task->wcet + 2*cxtSwitchTime + Interference(task, oldr);
		while(fabs(r - oldr) > SMALL_STEP) {
			oldr = r;
			r = task->wcet + 2*cxtSwitchTime + Interference(task, oldr);
			if(r > task->GetPeriod()) {
			//if(r> CONVERGENCE_LIMIT) {
				CString temp;
				temp.Format("The task %s on processor %s is not schedulable!",
					task->GetName(), task->parentProcessor->name);
				AfxMessageBox(temp);
				break;
			}
		}
		task->wcrt = r;
		//TODO: hack, assume bcrt == wcet.
		task->bcrt = task->wcet;
	}
}

//Assume rate monotonic priority assignment.
CTaskNode *CProcessorNode::GetMaxPriorityTask() {
	for(int i = NUM_RATES - 1; i >= 0; i--) {
		if(tasks[i].wcet > 0.0) {
			return &tasks[i];
		}
	}
	ASSERT(0);
	return NULL;
}

//calculate the best-case response time based on william henderson's paper.
#if 0
double CProcessorNode::Pj(const CTaskNode *tNode, double Pj) {
	double sum = 0;
	CTaskNode *maxPriorityTask = GetMaxPriorityTask();
	ASSERT(maxPriorityTask);

	for(int i = 0; i < NUM_TASKS; i++) {
		CTaskNode *tNode2 = &tasks[i];
		if(tNode2 == tNode || tNode2->wcet == 0.0 || tNode2->priority < tNode->priority)
			continue;
		sum += ceil(Pj/tNode2->GetPeriod()) *
			(tNode2->wcet + (tNode2 == maxPriorityTask ? 2 : 0) * pNode->cxtSwitchTime);
	}
	return sum;
}
/*
	pos = pNode->taskNodeList.GetHeadPosition();
	while(pos) {
		CTaskNode *tNode2 = pNode->taskNodeList.GetNext(pos);
		if(tNode == tNode2) continue;
		if(tNode2->priority > tNode->priority) {
			sum += ceil(Pj/tNode2->period) *
			(tNode2->wcet + (tNode2 == maxPriorityTask ? 2 : 0) * pNode->cxtSwitchTime);
		}
	}

	return sum;
}
*/
double CProcessorNode::BestCaseInteference(const CTaskNode *tNode, double responseTime) {
	double sum = 0;
	CTaskNode *maxPriorityTask = pNode->GetMaxPriorityTask();
	ASSERT(maxPriorityTask);

	
	
	pos = pNode->taskNodeList.GetHeadPosition();
	while(pos) {
		CTaskNode *tNode2 = pNode->taskNodeList.GetNext(pos);
		if(tNode == tNode2) continue;
		if(tNode2->priority > tNode->priority) {
			sum += ceil((responseTime - tNode2->releaseJitter + tNode2->Pj)/tNode2->period - 1) *
				(tNode2->wcet + (tNode2 == maxPriorityTask ? 2 : 0) * pNode->cxtSwitchTime);
		}
	}

	return sum;
}
#endif

SubscribePort UDMFindSubPortByGUID(Udm::SmartDataNetwork *backend, CString & guid1) {
	System system = System::Cast(backend->GetRootObject());
	set<Network> networks = system.Network_kind_children();
	for(set<Network>::iterator ii = networks.begin(); ii != networks.end(); ii++) {
		set<Processor> procs = Network::Cast(*ii).Processor_kind_children();
		int size = procs.size();
		for(set<Processor>::iterator ii2 = procs.begin(); ii2 != procs.end(); ii2++) {
			set<ComponentInstance> cInsts = ii2->ComponentInstance_children();
			for(set<ComponentInstance>::iterator ii3 = cInsts.begin(); ii3 != cInsts.end(); ii3++) {
				ComponentInstance cInst = *ii3;
/*
			set<Process> processes = Processor::Cast(*ii2).Process_kind_children();
			for(set<Process>::iterator ii3 = processes.begin(); ii3 != processes.end(); ii3++) {
				set<Component> comps2 = Process::Cast(*ii3).Component_kind_children();
				for(set<Component>::iterator ii4 = comps2.begin(); ii4 != comps2.end(); ii4++) {
					ComponentInstance cInst = Component::Cast(*ii4).dst_end();
*/					set<SubscribePort> subPorts = cInst.SubscribePort_kind_children();
					for(set<SubscribePort>::iterator ii5 = subPorts.begin(); ii5 != subPorts.end(); ii5++) {
						SubscribePort subPort = SubscribePort::Cast(*ii5);
						CString guid = CString(string(subPort.guid()).c_str());
						if(guid == guid1)
							return subPort;
					}
			}
		}
	}
	ASSERT(false);
	return NULL;
}

#if 0
Facet UDMFindFacetByGUID(Udm::SmartDataNetwork *backend, int guid1) {
	System system = System::Cast(backend->GetRootObject());
	set<Network> networks = system.Network_kind_children();
	for(set<Network>::iterator ii = networks.begin(); ii != networks.end(); ii++) {
		set<Processor> procs = Network::Cast(*ii).Processor_kind_children();
		int size = procs.size();
		for(set<Processor>::iterator ii2 = procs.begin(); ii2 != procs.end(); ii2++) {
			set<ComponentInstance> cInsts = ii2->ComponentInstance_children();
			for(set<ComponentInstance>::iterator ii3 = cInsts.begin(); ii3 != cInsts.end(); ii3++) {
				ComponentInstance cInst = *ii3;
/*
			set<Process> processes = Processor::Cast(*ii2).Process_kind_children();
			for(set<Process>::iterator ii3 = processes.begin(); ii3 != processes.end(); ii3++) {
				set<Component> comps2 = Process::Cast(*ii3).Component_kind_children();
				for(set<Component>::iterator ii4 = comps2.begin(); ii4 != comps2.end(); ii4++) {
					ComponentInstance cInst = Component::Cast(*ii4).dst_end();
*/					set<Facet> facets = cInst.Facet_kind_children();
					for(set<Facet>::iterator ii5 = facets.begin(); ii5 != facets.end(); ii5++) {
						Facet facet = Facet::Cast(*ii5);
						CString guid = CString(string(subPort.guid()).c_str());
						if(guid == guid1)
							return facet;
					}
			}
		}
	}
	ASSERT(false);
	return NULL;
}

#endif
ComponentInstance UDMFindComponentInstByGUID(Udm::SmartDataNetwork *backend, CString & guid1) {
	System system = System::Cast(backend->GetRootObject());
	set<Network> networks = system.Network_kind_children();
	for(set<Network>::iterator ii = networks.begin(); ii != networks.end(); ii++) {
		set<Processor> procs = Network::Cast(*ii).Processor_kind_children();
		int size = procs.size();
		for(set<Processor>::iterator ii2 = procs.begin(); ii2 != procs.end(); ii2++) {
			set<ComponentInstance> cInsts = ii2->ComponentInstance_children();
			for(set<ComponentInstance>::iterator ii3 = cInsts.begin(); ii3 != cInsts.end(); ii3++) {
				ComponentInstance cInst = *ii3;
				CString guid = CString(string(cInst.guid()).c_str());
				if(guid == guid1) 
					return cInst;
				
			}
		}
	}
	ASSERT(false);
	return NULL;
}

Processor UDMFindProcessorByGUID(Udm::SmartDataNetwork *backend, CString & guid1) {
	System system = System::Cast(backend->GetRootObject());
	set<Network> networks = system.Network_kind_children();
	for(set<Network>::iterator ii = networks.begin(); ii != networks.end(); ii++) {
		set<Processor> procs = Network::Cast(*ii).Processor_kind_children();
		int size = procs.size();
		for(set<Processor>::iterator ii2 = procs.begin(); ii2 != procs.end(); ii2++) {
			Processor proc = *ii2;
			CString guid = CString(string(proc.guid()).c_str());
			if(guid == guid1)
				return proc;
		}
	}
	ASSERT(false);
	return NULL;
}


//First, from Udm data structure, get each SubscribePort, find its counterpart in
//my DS, get its taskNode. Then go back to Udm DS, and find the Thread
//corresponding to taskNode->rate. Then in Udm DS, add and remove ports.
void UpdateAIFWithRateAssignment(Udm::SmartDataNetwork *backend) {
	//Testing Code
	///////////////////////////////////////
#if 0
	{
	System system = System::Cast(backend->GetRootObject());
	set<Network> networks = system.Network_kind_children();
	for(set<Network>::iterator ii = networks.begin(); ii != networks.end(); ii++) {
		set<Processor> procs = Network::Cast(*ii).Processor_kind_children();
		int size = procs.size();
		for(set<Processor>::iterator ii2 = procs.begin(); ii2 != procs.end(); ii2++) {
			CString guid = CString(string(ii2->guid()).c_str());
			CProcessorNode *processorNode = gTheSystem.FindProcessorNodeByGUID(guid);
			Processor processor = *ii2;

			set<ComponentInstance> compInsts = processor.ComponentInstance_kind_children();
			for(set<ComponentInstance>::iterator ii4 = compInsts.begin(); ii4 != compInsts.end(); ii4++) {
				ComponentInstance cInst = *ii4;
				set<SubscribePort> subPorts = cInst.SubscribePort_kind_children();
				for(set<SubscribePort>::iterator ii5 = subPorts.begin(); ii5 != subPorts.end(); ii5++) {
					SubscribePort subPort = *ii5;
					CString guid = CString(string(subPort.guid()).c_str());
					CPortNode *pNode = gTheSystem.FindPortNodeByGUID(guid);
					CTaskNode *tNode = pNode->parentTask;
					//It is possible that a port is not assigned a task.
					if(!tNode) continue;
					set<Process> processes = processor.Process_kind_children();
					for(set<Process>::iterator ii6 = processes.begin(); ii6 != processes.end(); ii6++) {
						set<Thread> threads = Process::Cast(*ii6).Thread_kind_children();
						for(set<Thread>::iterator ii7 = threads.begin(); ii7 != threads.end(); ii7++) {
							Thread thr = Thread::Cast(*ii7);
							set<TriggerQoSProperties> tqps = thr.tQoSProp();
							for(set<TriggerQoSProperties>::iterator itqp = tqps.begin(); itqp != tqps.end(); itqp++) {
								TriggerQoSProperties tQoSProp = *itqp;
								//thr.tQoSProp() += tQoSProp;
								tQoSProp.owner() = NULL;
							}
						}
					}
				}
			}
		}
	}
	return;
	}
#endif
	///////////////////////////////////////
	System system = System::Cast(backend->GetRootObject());
	set<Network> networks = system.Network_kind_children();
	for(set<Network>::iterator ii = networks.begin(); ii != networks.end(); ii++) {
		set<Processor> procs = Network::Cast(*ii).Processor_kind_children();
		int size = procs.size();
		for(set<Processor>::iterator ii2 = procs.begin(); ii2 != procs.end(); ii2++) {
			CString guid = CString(string(ii2->guid()).c_str());
			CProcessorNode *processorNode = gTheSystem.FindProcessorNodeByGUID(guid);
			Processor processor = *ii2;

			set<ComponentInstance> compInsts = processor.ComponentInstance_kind_children();
			for(set<ComponentInstance>::iterator ii4 = compInsts.begin(); ii4 != compInsts.end(); ii4++) {
				ComponentInstance cInst = *ii4;
				set<SubscribePort> subPorts = cInst.SubscribePort_kind_children();
				for(set<SubscribePort>::iterator ii5 = subPorts.begin(); ii5 != subPorts.end(); ii5++) {
					SubscribePort subPort = *ii5;
					CString guid = CString(string(subPort.guid()).c_str());
					CPortNode *pNode = gTheSystem.FindPortNodeByGUID(guid);
					CTaskNode *tNode = pNode->parentTask;
					//It is possible that a port is not assigned a task.
					if(!tNode) continue;
					set<Process> processes = processor.Process_kind_children();
					for(set<Process>::iterator ii6 = processes.begin(); ii6 != processes.end(); ii6++) {
						set<Thread> threads = Process::Cast(*ii6).Thread_kind_children();
						for(set<Thread>::iterator ii7 = threads.begin(); ii7 != threads.end(); ii7++) {
							Thread thr = Thread::Cast(*ii7);
							CString name = string(thr.name()).c_str();
							rate_t rate = GetRateFromName(name);
							//Match up the rate in UDM DS and my DS, establish link between 2 DSs.
							if(rate == tNode->rate) {
								set<TriggerQoSProperties> tqps = subPort.action();
								for(set<TriggerQoSProperties>::iterator itqp = tqps.begin(); itqp != tqps.end(); itqp++) {
									TriggerQoSProperties tQoSProp = *itqp;
									thr.tQoSProp() += tQoSProp;
									tQoSProp.owner() = thr;
								}
								break;
							}
						}
					}
				}
			}
		}//end of for(set<Processor>::iterator 
	}
}

#if 0			

			set<Process> processes = Processor::Cast(*ii2).Process_kind_children();
			for(set<Process>::iterator ii3 = processes.begin(); ii3 != processes.end(); ii3++) {
				set<Thread> threads = Process::Cast(*ii3).Thread_kind_children();
				for(set<Thread>::iterator ii5 = threads.begin(); ii5 != threads.end(); ii5++) {
					Thread thr = Thread::Cast(*ii5);
					CString name = string(thr.name()).c_str();
					rate_t rate = GetRateFromName(name);
					CTaskNode * tNode = processorNode->GetTaskFromRate(rate);
				
					POSITION pos = tNode->ports.GetHeadPosition();
					while(pos) {
						CPortNode *pNode = tNode->ports.GetNext(pos);
						if(pNode->type != SUBSCRIBEPORT) continue;
						//SubscribePort subPort = UDMFindSubPortByGUID(backend, pNode->guid);
						SubscribePort *subPort; 
					/*	POSITION pos4 = PortPtrMap.GetStartPosition();
						while(pos4) {
							PortPtrMap.GetNextAssoc(pos, pNode, subPort);
						}*/
						CString guidStr;
						guidStr.Format("%d", pNode->guid);
						//BOOL ret = SubPortPtrMap.Lookup(guidStr, subPort);
						BOOL ret = SubPortPtrMap.Lookup(guidStr, subPort);
						ASSERT(ret);
						ASSERT(subPort);
						CString name(string(subPort->name()).c_str());
						set<TriggerQoSProperties> tqps = subPort->action();
						for(set<TriggerQoSProperties>::iterator itqp = tqps.begin(); itqp != tqps.end(); itqp++) {
							TriggerQoSProperties tQoSProp = *itqp;
							thr.tQoSProp() += tQoSProp;
							tQoSProp.owner() = thr;
						}
					}
	
				}

			}
		}
	}
}
#endif


void UpdateAIFWithAllocResults(Udm::SmartDataNetwork *backend) {
	//First remove all components allocated to a processor,
#if 0
	{
	System system = System::Cast(backend->GetRootObject());
	set<Network> networks = system.Network_kind_children();
	for(set<Network>::iterator ii = networks.begin(); ii != networks.end(); ii++) {
		set<Processor> procs = Network::Cast(*ii).Processor_kind_children();
		int size = procs.size();
		for(set<Processor>::iterator ii2 = procs.begin(); ii2 != procs.end(); ii2++) {
			CString guid = CString(string(ii2->guid()).c_str());
			Processor processor = *ii2;
			set<Process> processes = processor.Process_kind_children();
				Process theProcess;
				for(set<Process>::iterator ii = processes.begin(); ii != processes.end(); ii++) {
					theProcess = *ii;
					break;
				}
				ASSERT(theProcess);	
				//How do I remove all component links from a Process? 
				set<Component> components = theProcess.Component_kind_children();
				for(set<Component>::iterator ii3 = components.begin(); ii3 != components.end(); ii3++) {
					Component component = *ii3;
					component.parent() = NULL;
					//component.owner_end() = NULL;
					//theProcess.dst().Remove_all();
				}
		}
	}
	}
#endif
	//Then update with the new allocation information.
	System system = System::Cast(backend->GetRootObject());
	set<Network> networks = system.Network_kind_children();
	for(set<Network>::iterator ii = networks.begin(); ii != networks.end(); ii++) {
		set<Processor> procs = Network::Cast(*ii).Processor_kind_children();
		int size = procs.size();
		for(set<Processor>::iterator ii2 = procs.begin(); ii2 != procs.end(); ii2++) {
			CString original_guid = CString(string(ii2->guid()).c_str());
			//CProcessorNode *processorNode = gTheSystem.FindProcessorNodeByGUID(guid);
			Processor processor = *ii2;
			set<Process> processes = processor.Process_kind_children();

			
			//Remove all thread-port assignments after allocation
			for(set<Process>::iterator ii6 = processes.begin(); ii6 != processes.end(); ii6++) {
				set<Thread> threads = Process::Cast(*ii6).Thread_kind_children();
				for(set<Thread>::iterator ii7 = threads.begin(); ii7 != threads.end(); ii7++) {
					Thread thr = Thread::Cast(*ii7);
					set<TriggerQoSProperties> tqps = thr.tQoSProp();
					for(set<TriggerQoSProperties>::iterator itqp = tqps.begin(); itqp != tqps.end(); itqp++) {
						TriggerQoSProperties tQoSProp = *itqp;
						//thr.tQoSProp() += tQoSProp;
						tQoSProp.owner() = NULL;
					}
				}
			}

			Process originalProcess;
			for(set<Process>::iterator ii = processes.begin(); ii != processes.end(); ii++) {
				originalProcess = *ii;
				break;
			}
			ASSERT(originalProcess);	

			set<ComponentInstance> compInsts = processor.ComponentInstance_kind_children();
			for(set<ComponentInstance>::iterator ii4 = compInsts.begin(); ii4 != compInsts.end(); ii4++) {
				ComponentInstance cInst = *ii4;
				//HACK: treat support components exactly the same as master components.
				//Support components are proxies, not targets for distribution.
				//if(cInst.type() == SupportComponent::meta) continue;

				CString guid = CString(string(cInst.guid()).c_str());			
				CComponentNode *cNode = gTheSystem.FindCompNodeByGUID(guid);
				CProcessorNode *pNode = cNode->processor_allocation;
				
				//If the allocated processor is the same as its original allocation, then do nothing.
				//TODO: hack here. check if pNode is null.
				ASSERT(pNode);
				if(original_guid == pNode->guid) continue;

				
				Processor processor_allocation = UDMFindProcessorByGUID(backend, pNode->guid);
				
				set<Process> processes = processor_allocation.Process_kind_children();
				Process theProcess;
				for(set<Process>::iterator ii = processes.begin(); ii != processes.end(); ii++) {
					theProcess = *ii;
					break;
				}
				ASSERT(theProcess);	

				//Move both the pointer and the component instance to the destination processor.
				Component component = cInst.owner();
				component.owner_end() = theProcess;
				component.parent() = theProcess;
				
				cInst.parent() = processor_allocation;
			//	cInst.owner() = processor_allocation;
				/*
				AIF::NormalComponent newObj = AIF::NormalComponent::Create(theProcess);
				//theProcess.dst() += newObj;
				newObj.dst_end() = cInst;
				newObj.owner_end() = theProcess;
				newObj.parent() = theProcess;

				newObj.name() = cInst.name();
				*/
			}

		}
	}

	//After component allocation, reopen the AIF file to update the treeview and listview
	//displays.
	CAvionicsDoc *pDoc = (CAvionicsDoc*) GetDocumentPtr();
	pDoc->OpenAIFFile();
}








#if 0

	int count1 = 0, count2 = 0;
/*
	int numClusters = 0
	for(vertex v = 1; v <= n; v++) {
		if(firstout(v) == 0 && firstin(v) == 0 &&
			vertices[v].merged_vertices.get_size() == 1) 
			continue;
		numClusters++;
	}

	int numProcessors = gTheSystem.processorNodeList.GetCount();

	ASSERT(numClusters >= numProcessors);
*/

	System system = System::Cast(backend->GetRootObject());
	set<Network> networks = system.Network_kind_children();
	for(set<Network>::iterator ii = networks.begin(); ii != networks.end(); ii++) {
		Network network = *ii;
		set<Processor> procs = Network::Cast(*ii).Processor_kind_children();
		//Processor processor = Processor::Create(network);
		//processor.name() = "crap";
		//processor.parent() = network;
		for(set<Processor>::iterator ii2 = procs.begin(); ii2 != procs.end(); ii2++) {
			Processor processor = *ii2;
			set<Process> processes = processor.Process_kind_children();
			Process theProcess;
			for(set<Process>::iterator ii = processes.begin(); ii != processes.end(); ii++) {
				theProcess = *ii;
				break;
			}
			ASSERT(theProcess);	

			CString processorGuid = CString(string(processor.guid()).c_str());
			CProcessorNode *pNode = gTheSystem.FindProcessorNodeByGUID(processorGuid);
			POSITION pos = pNode->components_allocation.GetHeadPosition();
			while(pos) {
				CComponentNode *cNode = pNode->components_allocation.GetNext(pos);
				AIF::NormalComponent newObj = AIF::NormalComponent::Create(theProcess);
				//newObj.dst_end() = cInst;
				newObj.parent() = theProcess;
			//	newObj.name() = "newmyobj";
			//	newObj.guid() = "3434";
			}
		}
	}

	return;
	///////////testing code//////////////////////////
		
		POSITION pos2 = gTheSystem.processorNodeList.GetHeadPosition();
		while(pos2) {
			CProcessorNode *pNode = gTheSystem.processorNodeList.GetNext(pos2);
			Processor proc = UDMFindProcessorByGUID(backend, pNode->guid);
			//For now assume each processor contains exactly one process.
			set<Process> processes = proc.Process_kind_children();
			Process theProcess;
			for(set<Process>::iterator ii = processes.begin(); ii != processes.end(); ii++) {
				theProcess = *ii;
				break;
			}
			ASSERT(theProcess);	

			//Remove all the old components from the process.
			set<Component> comps = theProcess.Component_kind_children();
			for(set<Component>::iterator ii2 = comps.begin(); ii2 != comps.end(); ii2++) {
				Component component = *ii2;
				component.parent() = NULL;
			//	theProcess.dst() -= component;
			}

			//Add the new components.
			//Node *n = vertices[v].merged_vertices.get_head();
			//while(n) {
			POSITION pos = pNode->components.GetHeadPosition();
			while(pos) {
				CComponentNode *cNode = pNode->components.GetNext(pos);
				if(cNode->isTimer) continue;
				ComponentInstance cInst = UDMFindComponentInstByGUID(backend, cNode->guid);

				AIF::NormalComponent newObj = AIF::NormalComponent::Create(theProcess);
				newObj.dst_end() = cInst;
				newObj.parent() = theProcess;
		//		set<Component> comps = theProcess.dst();
		//		comps += newObj;
			}
		}
}
#endif
#if 0
	edge_type_t type = INVOCATION_OTHERS;
	set<CallOut> cos = iRecep->co();
	for(set<CallOut>::iterator iCallOut = cos.begin(); iCallOut != cos.end();	iCallOut++) {
		CallOut co = *iCallOut;
		Method method = co.method();
		CString methodName(string(method.name()).c_str());
		if(methodName.Left(3) == "Get" || methodName.Left(3) == "get") {
			type = INVOCATION_GET;
		}
	}
#endif