#ifndef MOBIES_AIF_CORBA_H
#define MOBIES_AIF_CORBA_H
// header file AIF.h generated from diagram AIF
// generated on Sat Jul 05 05:52:23 2003
#include "UdmCORBA.h"

#ifndef MOBIES_UDMBASE_H
#include "UdmBase.h"
#endif

namespace AIF_CORBA {

	typedef Udm::Object Object;

	class SubscribePort;
	class CallOut;
	class Interactions;
	class TimerComponent;
	class Method;
	class Action;
	class InvocationQoSProperties;
	class AIFObject;
	class TriggerQoSProperties;
	class InvocationConnection;
	class PublishPort;
	class ComponentInstance;
	class Event;
	class ComponentMode;
	class ModeTransition;
	class Interface;
	class EventPort;
	class System;
	class ApplicationComponent;
	class Receptacle;
	class SupportComponent;
	class Facet;
	class BackupComponent;
	class SystemMode;
	class Component;
	class Processor;
	class CommPort;
	class Link;
	class Process;
	class Thread;
	class NormalComponent;
	class Network;

	void Initialize();
	extern Udm::UdmDiagram diagram;

	class AIFObject :  public Object {
	 public:
		static Uml::Class meta;

		AIFObject() { }
		AIFObject(Udm::ObjectImpl *impl) : Object(impl) { }
		AIFObject(const AIFObject &master) : Object(master) { }
		static AIFObject Cast(const Object &a) { return __Cast(a, meta); }

		static AIFObject Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		AIFObject CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		AIFObject CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<AIFObject> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::AIFObject>(impl);}
	
		Udm::DerivedAttr<AIF_CORBA::AIFObject> Derived() { return Udm::DerivedAttr<AIF_CORBA::AIFObject>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::AIFObject> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::AIFObject>(impl);}

		static Uml::Attribute meta_guid;
		Udm::StringAttr guid() const { return Udm::StringAttr(impl, meta_guid); }

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		static Uml::Attribute meta_creator;
		Udm::StringAttr creator() const { return Udm::StringAttr(impl, meta_creator); }

		static Uml::Attribute meta_creationDate;
		Udm::StringAttr creationDate() const { return Udm::StringAttr(impl, meta_creationDate); }

		static Uml::Attribute meta_lastModifier;
		Udm::StringAttr lastModifier() const { return Udm::StringAttr(impl, meta_lastModifier); }

		static Uml::Attribute meta_lastModDate;
		Udm::StringAttr lastModDate() const { return Udm::StringAttr(impl, meta_lastModDate); }

		static Uml::Attribute meta_locked;
		Udm::BooleanAttr locked() const { return Udm::BooleanAttr(impl, meta_locked); }

		static Uml::Attribute meta_locker;
		Udm::StringAttr locker() const { return Udm::StringAttr(impl, meta_locker); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class CallOut :  public AIFObject {
	 public:
		static Uml::Class meta;

		CallOut() { }
		CallOut(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		CallOut(const CallOut &master) : AIFObject(master) { }
		static CallOut Cast(const Object &a) { return __Cast(a, meta); }

		static CallOut Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		CallOut CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		CallOut CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<CallOut> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::CallOut>(impl);}

		Udm::DerivedAttr<AIF_CORBA::CallOut> Derived() { return Udm::DerivedAttr<AIF_CORBA::CallOut>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::CallOut> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::CallOut>(impl);}

		static Uml::AssociationRole meta_method;
		Udm::PointerAttr<AIF_CORBA::Method> method() const { return Udm::PointerAttr<AIF_CORBA::Method>(impl, meta_method); }

		static Uml::AssociationRole meta_receptacle;
		Udm::PointerAttr<AIF_CORBA::Receptacle> receptacle() const { return Udm::PointerAttr<AIF_CORBA::Receptacle>(impl, meta_receptacle); }

		static Uml::AssociationRole meta_action;
		Udm::AssocAttr<AIF_CORBA::Action> action() const { return Udm::AssocAttr<AIF_CORBA::Action>(impl, meta_action); }

		static Uml::CompositionParentRole meta_ComponentInstance_parent;
		Udm::ParentAttr<AIF_CORBA::ComponentInstance> ComponentInstance_parent() const { return Udm::ParentAttr<AIF_CORBA::ComponentInstance>(impl, meta_ComponentInstance_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class Interactions :  public AIFObject {
	 public:
		static Uml::Class meta;

		Interactions() { }
		Interactions(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		Interactions(const Interactions &master) : AIFObject(master) { }
		static Interactions Cast(const Object &a) { return __Cast(a, meta); }

		static Interactions Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Interactions CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Interactions CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Interactions> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::Interactions>(impl);}

		Udm::DerivedAttr<AIF_CORBA::Interactions> Derived() { return Udm::DerivedAttr<AIF_CORBA::Interactions>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::Interactions> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::Interactions>(impl);}

		static Uml::AssociationRole meta_SystemMode;
		Udm::AssocAttr<AIF_CORBA::SystemMode> SystemMode() const { return Udm::AssocAttr<AIF_CORBA::SystemMode>(impl, meta_SystemMode); }

		static Uml::AssociationRole meta_componentInstances;
		Udm::AssocAttr<AIF_CORBA::ComponentInstance> componentInstances() const { return Udm::AssocAttr<AIF_CORBA::ComponentInstance>(impl, meta_componentInstances); }

		static Uml::CompositionChildRole meta_Event_children;
		Udm::ChildrenAttr<AIF_CORBA::Event> Event_children() const { return Udm::ChildrenAttr<AIF_CORBA::Event>(impl, meta_Event_children); }

		static Uml::CompositionChildRole meta_TimerComponent_children;
		Udm::ChildrenAttr<AIF_CORBA::TimerComponent> TimerComponent_children() const { return Udm::ChildrenAttr<AIF_CORBA::TimerComponent>(impl, meta_TimerComponent_children); }

		static Uml::CompositionChildRole meta_InvocationConnection_children;
		Udm::ChildrenAttr<AIF_CORBA::InvocationConnection> InvocationConnection_children() const { return Udm::ChildrenAttr<AIF_CORBA::InvocationConnection>(impl, meta_InvocationConnection_children); }

		Udm::ChildrenAttr<AIF_CORBA::TimerComponent> TimerComponent_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::TimerComponent>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::AIFObject> AIFObject_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::InvocationConnection> InvocationConnection_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::InvocationConnection>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::Event> Event_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::Event>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_System_parent;
		Udm::ParentAttr<AIF_CORBA::System> System_parent() const { return Udm::ParentAttr<AIF_CORBA::System>(impl, meta_System_parent); }

		Udm::ParentAttr<AIF_CORBA::System> parent() const { return Udm::ParentAttr<AIF_CORBA::System>(impl, Udm::NULLPARENTROLE); }
	};

	class TimerComponent :  public AIFObject {
	 public:
		static Uml::Class meta;

		TimerComponent() { }
		TimerComponent(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		TimerComponent(const TimerComponent &master) : AIFObject(master) { }
		static TimerComponent Cast(const Object &a) { return __Cast(a, meta); }

		static TimerComponent Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		TimerComponent CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		TimerComponent CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<TimerComponent> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::TimerComponent>(impl);}

		Udm::DerivedAttr<AIF_CORBA::TimerComponent> Derived() { return Udm::DerivedAttr<AIF_CORBA::TimerComponent>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::TimerComponent> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::TimerComponent>(impl);}

		static Uml::Attribute meta_period;
		Udm::StringAttr period() const { return Udm::StringAttr(impl, meta_period); }

		static Uml::AssociationRole meta_event;
		Udm::AssocAttr<AIF_CORBA::Event> event() const { return Udm::AssocAttr<AIF_CORBA::Event>(impl, meta_event); }

		static Uml::CompositionParentRole meta_Interactions_parent;
		Udm::ParentAttr<AIF_CORBA::Interactions> Interactions_parent() const { return Udm::ParentAttr<AIF_CORBA::Interactions>(impl, meta_Interactions_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class Method :  public AIFObject {
	 public:
		static Uml::Class meta;

		Method() { }
		Method(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		Method(const Method &master) : AIFObject(master) { }
		static Method Cast(const Object &a) { return __Cast(a, meta); }

		static Method Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Method CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Method CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Method> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::Method>(impl);}

		Udm::DerivedAttr<AIF_CORBA::Method> Derived() { return Udm::DerivedAttr<AIF_CORBA::Method>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::Method> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::Method>(impl);}

		static Uml::Attribute meta_dataSize;
		Udm::IntegerAttr dataSize() const { return Udm::IntegerAttr(impl, meta_dataSize); }

		static Uml::AssociationRole meta_co;
		Udm::AssocAttr<AIF_CORBA::CallOut> co() const { return Udm::AssocAttr<AIF_CORBA::CallOut>(impl, meta_co); }

		static Uml::AssociationRole meta_iqos;
		Udm::AssocAttr<AIF_CORBA::InvocationQoSProperties> iqos() const { return Udm::AssocAttr<AIF_CORBA::InvocationQoSProperties>(impl, meta_iqos); }

		static Uml::CompositionParentRole meta_Interface_parent;
		Udm::ParentAttr<AIF_CORBA::Interface> Interface_parent() const { return Udm::ParentAttr<AIF_CORBA::Interface>(impl, meta_Interface_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class Action :  public AIFObject {
	 public:
		static Uml::Class meta;

		Action() { }
		Action(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		Action(const Action &master) : AIFObject(master) { }
		static Action Cast(const Object &a) { return __Cast(a, meta); }

		static Action Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Action CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Action CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Action> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::Action>(impl);}

		Udm::DerivedAttr<AIF_CORBA::Action> Derived() { return Udm::DerivedAttr<AIF_CORBA::Action>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::Action> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::Action>(impl);}

		static Uml::Attribute meta_WCET;
		Udm::StringAttr WCET() const { return Udm::StringAttr(impl, meta_WCET); }

		static Uml::AssociationRole meta_trigger, meta_trigger_rev;
		Udm::AClassAssocAttr<AIF_CORBA::TriggerQoSProperties, AIF_CORBA::SubscribePort> trigger() const { return Udm::AClassAssocAttr<AIF_CORBA::TriggerQoSProperties, AIF_CORBA::SubscribePort>(impl, meta_trigger, meta_trigger_rev); }

		static Uml::AssociationRole meta_co;
		Udm::AssocAttr<AIF_CORBA::CallOut> co() const { return Udm::AssocAttr<AIF_CORBA::CallOut>(impl, meta_co); }

		static Uml::AssociationRole meta_port;
		Udm::AssocAttr<AIF_CORBA::PublishPort> port() const { return Udm::AssocAttr<AIF_CORBA::PublishPort>(impl, meta_port); }

		static Uml::AssociationRole meta_iqos;
		Udm::PointerAttr<AIF_CORBA::InvocationQoSProperties> iqos() const { return Udm::PointerAttr<AIF_CORBA::InvocationQoSProperties>(impl, meta_iqos); }

		static Uml::AssociationRole meta_modes;
		Udm::AssocAttr<AIF_CORBA::ComponentMode> modes() const { return Udm::AssocAttr<AIF_CORBA::ComponentMode>(impl, meta_modes); }

		static Uml::CompositionParentRole meta_ComponentInstance_parent;
		Udm::ParentAttr<AIF_CORBA::ComponentInstance> ComponentInstance_parent() const { return Udm::ParentAttr<AIF_CORBA::ComponentInstance>(impl, meta_ComponentInstance_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class InvocationQoSProperties :  public AIFObject {
	 public:
		static Uml::Class meta;

		InvocationQoSProperties() { }
		InvocationQoSProperties(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		InvocationQoSProperties(const InvocationQoSProperties &master) : AIFObject(master) { }
		static InvocationQoSProperties Cast(const Object &a) { return __Cast(a, meta); }

		static InvocationQoSProperties Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		InvocationQoSProperties CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		InvocationQoSProperties CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<InvocationQoSProperties> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::InvocationQoSProperties>(impl);}

		Udm::DerivedAttr<AIF_CORBA::InvocationQoSProperties> Derived() { return Udm::DerivedAttr<AIF_CORBA::InvocationQoSProperties>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::InvocationQoSProperties> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::InvocationQoSProperties>(impl);}

		static Uml::Attribute meta_requiredPeriod;
		Udm::StringAttr requiredPeriod() const { return Udm::StringAttr(impl, meta_requiredPeriod); }

		static Uml::Attribute meta_aggregateWCET;
		Udm::StringAttr aggregateWCET() const { return Udm::StringAttr(impl, meta_aggregateWCET); }

		static Uml::Attribute meta_expectedPeriod;
		Udm::StringAttr expectedPeriod() const { return Udm::StringAttr(impl, meta_expectedPeriod); }

		static Uml::Attribute meta_deadline;
		Udm::StringAttr deadline() const { return Udm::StringAttr(impl, meta_deadline); }

		static Uml::Attribute meta_priority;
		Udm::StringAttr priority() const { return Udm::StringAttr(impl, meta_priority); }

		static Uml::Attribute meta_importance;
		Udm::StringAttr importance() const { return Udm::StringAttr(impl, meta_importance); }

		static Uml::AssociationRole meta_method;
		Udm::PointerAttr<AIF_CORBA::Method> method() const { return Udm::PointerAttr<AIF_CORBA::Method>(impl, meta_method); }

		static Uml::AssociationRole meta_action;
		Udm::PointerAttr<AIF_CORBA::Action> action() const { return Udm::PointerAttr<AIF_CORBA::Action>(impl, meta_action); }

		static Uml::AssociationRole meta_facet;
		Udm::PointerAttr<AIF_CORBA::Facet> facet() const { return Udm::PointerAttr<AIF_CORBA::Facet>(impl, meta_facet); }

		static Uml::AssociationRole meta_owner;
		Udm::PointerAttr<AIF_CORBA::Thread> owner() const { return Udm::PointerAttr<AIF_CORBA::Thread>(impl, meta_owner); }

		static Uml::CompositionParentRole meta_ComponentInstance_parent;
		Udm::ParentAttr<AIF_CORBA::ComponentInstance> ComponentInstance_parent() const { return Udm::ParentAttr<AIF_CORBA::ComponentInstance>(impl, meta_ComponentInstance_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class TriggerQoSProperties :  public AIFObject {
	 public:
		static Uml::Class meta;

		TriggerQoSProperties() { }
		TriggerQoSProperties(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		TriggerQoSProperties(const TriggerQoSProperties &master) : AIFObject(master) { }
		static TriggerQoSProperties Cast(const Object &a) { return __Cast(a, meta); }

		static TriggerQoSProperties Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		TriggerQoSProperties CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		TriggerQoSProperties CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<TriggerQoSProperties> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::TriggerQoSProperties>(impl);}

		Udm::DerivedAttr<AIF_CORBA::TriggerQoSProperties> Derived() { return Udm::DerivedAttr<AIF_CORBA::TriggerQoSProperties>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::TriggerQoSProperties> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::TriggerQoSProperties>(impl);}

		static Uml::Attribute meta_requiredPeriod;
		Udm::StringAttr requiredPeriod() const { return Udm::StringAttr(impl, meta_requiredPeriod); }

		static Uml::Attribute meta_aggregateWCET;
		Udm::StringAttr aggregateWCET() const { return Udm::StringAttr(impl, meta_aggregateWCET); }

		static Uml::Attribute meta_expectedPeriod;
		Udm::StringAttr expectedPeriod() const { return Udm::StringAttr(impl, meta_expectedPeriod); }

		static Uml::Attribute meta_deadline;
		Udm::StringAttr deadline() const { return Udm::StringAttr(impl, meta_deadline); }

		static Uml::Attribute meta_priority;
		Udm::StringAttr priority() const { return Udm::StringAttr(impl, meta_priority); }

		static Uml::Attribute meta_importance;
		Udm::StringAttr importance() const { return Udm::StringAttr(impl, meta_importance); }

		static Uml::AssociationRole meta_owner;
		Udm::PointerAttr<AIF_CORBA::Thread> owner() const { return Udm::PointerAttr<AIF_CORBA::Thread>(impl, meta_owner); }

		static Uml::CompositionParentRole meta_ComponentInstance_parent;
		Udm::ParentAttr<AIF_CORBA::ComponentInstance> ComponentInstance_parent() const { return Udm::ParentAttr<AIF_CORBA::ComponentInstance>(impl, meta_ComponentInstance_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_trigger_end_;
		Udm::AssocEndAttr<AIF_CORBA::SubscribePort> trigger_end() const { return Udm::AssocEndAttr<AIF_CORBA::SubscribePort>(impl, meta_trigger_end_); }

		static Uml::AssociationRole meta_action_end_;
		Udm::AssocEndAttr<AIF_CORBA::Action> action_end() const { return Udm::AssocEndAttr<AIF_CORBA::Action>(impl, meta_action_end_); }

	};

	class InvocationConnection :  public AIFObject {
	 public:
		static Uml::Class meta;

		InvocationConnection() { }
		InvocationConnection(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		InvocationConnection(const InvocationConnection &master) : AIFObject(master) { }
		static InvocationConnection Cast(const Object &a) { return __Cast(a, meta); }

		static InvocationConnection Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		InvocationConnection CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		InvocationConnection CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<InvocationConnection> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::InvocationConnection>(impl);}

		Udm::DerivedAttr<AIF_CORBA::InvocationConnection> Derived() { return Udm::DerivedAttr<AIF_CORBA::InvocationConnection>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::InvocationConnection> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::InvocationConnection>(impl);}

		static Uml::Attribute meta_asynchronous;
		Udm::BooleanAttr asynchronous() const { return Udm::BooleanAttr(impl, meta_asynchronous); }

		static Uml::AssociationRole meta_implements;
		Udm::PointerAttr<AIF_CORBA::Link> implements() const { return Udm::PointerAttr<AIF_CORBA::Link>(impl, meta_implements); }

		static Uml::CompositionParentRole meta_Interactions_parent;
		Udm::ParentAttr<AIF_CORBA::Interactions> Interactions_parent() const { return Udm::ParentAttr<AIF_CORBA::Interactions>(impl, meta_Interactions_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_callout_end_;
		Udm::AssocEndAttr<AIF_CORBA::Receptacle> callout_end() const { return Udm::AssocEndAttr<AIF_CORBA::Receptacle>(impl, meta_callout_end_); }

		static Uml::AssociationRole meta_invokes_end_;
		Udm::AssocEndAttr<AIF_CORBA::Facet> invokes_end() const { return Udm::AssocEndAttr<AIF_CORBA::Facet>(impl, meta_invokes_end_); }

	};

	class ComponentInstance :  public AIFObject {
	 public:
		static Uml::Class meta;

		ComponentInstance() { }
		ComponentInstance(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		ComponentInstance(const ComponentInstance &master) : AIFObject(master) { }
		static ComponentInstance Cast(const Object &a) { return __Cast(a, meta); }

		static ComponentInstance Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		ComponentInstance CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		ComponentInstance CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<ComponentInstance> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::ComponentInstance>(impl);}

		Udm::DerivedAttr<AIF_CORBA::ComponentInstance> Derived() { return Udm::DerivedAttr<AIF_CORBA::ComponentInstance>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::ComponentInstance> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::ComponentInstance>(impl);}

		static Uml::Attribute meta_groupID;
		Udm::IntegerAttr groupID() const { return Udm::IntegerAttr(impl, meta_groupID); }

		static Uml::Attribute meta_itemID;
		Udm::IntegerAttr itemID() const { return Udm::IntegerAttr(impl, meta_itemID); }

		static Uml::AssociationRole meta_interactions;
		Udm::AssocAttr<AIF_CORBA::Interactions> interactions() const { return Udm::AssocAttr<AIF_CORBA::Interactions>(impl, meta_interactions); }

		static Uml::AssociationRole meta_owner, meta_owner_rev;
		Udm::AClassPointerAttr<AIF_CORBA::Component, AIF_CORBA::Process> owner() const { return Udm::AClassPointerAttr<AIF_CORBA::Component, AIF_CORBA::Process>(impl, meta_owner, meta_owner_rev); }

		static Uml::CompositionChildRole meta_InvocationQoSProperties_children;
		Udm::ChildrenAttr<AIF_CORBA::InvocationQoSProperties> InvocationQoSProperties_children() const { return Udm::ChildrenAttr<AIF_CORBA::InvocationQoSProperties>(impl, meta_InvocationQoSProperties_children); }

		static Uml::CompositionChildRole meta_TriggerQoSProperties_children;
		Udm::ChildrenAttr<AIF_CORBA::TriggerQoSProperties> TriggerQoSProperties_children() const { return Udm::ChildrenAttr<AIF_CORBA::TriggerQoSProperties>(impl, meta_TriggerQoSProperties_children); }

		static Uml::CompositionChildRole meta_Action_children;
		Udm::ChildrenAttr<AIF_CORBA::Action> Action_children() const { return Udm::ChildrenAttr<AIF_CORBA::Action>(impl, meta_Action_children); }

		static Uml::CompositionChildRole meta_ComponentMode_children;
		Udm::ChildrenAttr<AIF_CORBA::ComponentMode> ComponentMode_children() const { return Udm::ChildrenAttr<AIF_CORBA::ComponentMode>(impl, meta_ComponentMode_children); }

		static Uml::CompositionChildRole meta_EventPort_children;
		Udm::ChildrenAttr<AIF_CORBA::EventPort> EventPort_children() const { return Udm::ChildrenAttr<AIF_CORBA::EventPort>(impl, meta_EventPort_children); }

		static Uml::CompositionChildRole meta_ModeTransition_children;
		Udm::ChildrenAttr<AIF_CORBA::ModeTransition> ModeTransition_children() const { return Udm::ChildrenAttr<AIF_CORBA::ModeTransition>(impl, meta_ModeTransition_children); }

		static Uml::CompositionChildRole meta_Facet_children;
		Udm::ChildrenAttr<AIF_CORBA::Facet> Facet_children() const { return Udm::ChildrenAttr<AIF_CORBA::Facet>(impl, meta_Facet_children); }

		static Uml::CompositionChildRole meta_Receptacle_children;
		Udm::ChildrenAttr<AIF_CORBA::Receptacle> Receptacle_children() const { return Udm::ChildrenAttr<AIF_CORBA::Receptacle>(impl, meta_Receptacle_children); }

		static Uml::CompositionChildRole meta_CallOut_children;
		Udm::ChildrenAttr<AIF_CORBA::CallOut> CallOut_children() const { return Udm::ChildrenAttr<AIF_CORBA::CallOut>(impl, meta_CallOut_children); }

		Udm::ChildrenAttr<AIF_CORBA::SubscribePort> SubscribePort_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::SubscribePort>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::CallOut> CallOut_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::CallOut>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::Action> Action_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::Action>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::InvocationQoSProperties> InvocationQoSProperties_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::InvocationQoSProperties>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::AIFObject> AIFObject_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::TriggerQoSProperties> TriggerQoSProperties_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::TriggerQoSProperties>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::PublishPort> PublishPort_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::PublishPort>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::ComponentMode> ComponentMode_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::ComponentMode>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::ModeTransition> ModeTransition_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::ModeTransition>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::EventPort> EventPort_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::EventPort>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::Receptacle> Receptacle_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::Receptacle>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::Facet> Facet_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::Facet>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_Processor_parent;
		Udm::ParentAttr<AIF_CORBA::Processor> Processor_parent() const { return Udm::ParentAttr<AIF_CORBA::Processor>(impl, meta_Processor_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class Event :  public AIFObject {
	 public:
		static Uml::Class meta;

		Event() { }
		Event(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		Event(const Event &master) : AIFObject(master) { }
		static Event Cast(const Object &a) { return __Cast(a, meta); }

		static Event Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Event CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Event CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Event> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::Event>(impl);}

		Udm::DerivedAttr<AIF_CORBA::Event> Derived() { return Udm::DerivedAttr<AIF_CORBA::Event>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::Event> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::Event>(impl);}

		static Uml::AssociationRole meta_dst;
		Udm::AssocAttr<AIF_CORBA::SubscribePort> dst() const { return Udm::AssocAttr<AIF_CORBA::SubscribePort>(impl, meta_dst); }

		static Uml::AssociationRole meta_timer;
		Udm::PointerAttr<AIF_CORBA::TimerComponent> timer() const { return Udm::PointerAttr<AIF_CORBA::TimerComponent>(impl, meta_timer); }

		static Uml::AssociationRole meta_publish;
		Udm::PointerAttr<AIF_CORBA::PublishPort> publish() const { return Udm::PointerAttr<AIF_CORBA::PublishPort>(impl, meta_publish); }

		static Uml::CompositionParentRole meta_Interactions_parent;
		Udm::ParentAttr<AIF_CORBA::Interactions> Interactions_parent() const { return Udm::ParentAttr<AIF_CORBA::Interactions>(impl, meta_Interactions_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class ComponentMode :  public AIFObject {
	 public:
		static Uml::Class meta;

		ComponentMode() { }
		ComponentMode(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		ComponentMode(const ComponentMode &master) : AIFObject(master) { }
		static ComponentMode Cast(const Object &a) { return __Cast(a, meta); }

		static ComponentMode Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		ComponentMode CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		ComponentMode CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<ComponentMode> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::ComponentMode>(impl);}

		Udm::DerivedAttr<AIF_CORBA::ComponentMode> Derived() { return Udm::DerivedAttr<AIF_CORBA::ComponentMode>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::ComponentMode> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::ComponentMode>(impl);}

		static Uml::Attribute meta_initialMode;
		Udm::BooleanAttr initialMode() const { return Udm::BooleanAttr(impl, meta_initialMode); }

		static Uml::AssociationRole meta_subscribePorts;
		Udm::AssocAttr<AIF_CORBA::SubscribePort> subscribePorts() const { return Udm::AssocAttr<AIF_CORBA::SubscribePort>(impl, meta_subscribePorts); }

		static Uml::AssociationRole meta_actions;
		Udm::AssocAttr<AIF_CORBA::Action> actions() const { return Udm::AssocAttr<AIF_CORBA::Action>(impl, meta_actions); }

		static Uml::AssociationRole meta_publishPorts;
		Udm::AssocAttr<AIF_CORBA::PublishPort> publishPorts() const { return Udm::AssocAttr<AIF_CORBA::PublishPort>(impl, meta_publishPorts); }

		static Uml::AssociationRole meta_dst, meta_dst_rev;
		Udm::AClassAssocAttr<AIF_CORBA::ModeTransition, AIF_CORBA::ComponentMode> dst() const { return Udm::AClassAssocAttr<AIF_CORBA::ModeTransition, AIF_CORBA::ComponentMode>(impl, meta_dst, meta_dst_rev); }

		static Uml::AssociationRole meta_facets;
		Udm::AssocAttr<AIF_CORBA::Facet> facets() const { return Udm::AssocAttr<AIF_CORBA::Facet>(impl, meta_facets); }

		static Uml::AssociationRole meta_receptacles;
		Udm::AssocAttr<AIF_CORBA::Receptacle> receptacles() const { return Udm::AssocAttr<AIF_CORBA::Receptacle>(impl, meta_receptacles); }

		static Uml::AssociationRole meta_src, meta_src_rev;
		Udm::AClassAssocAttr<AIF_CORBA::ModeTransition, AIF_CORBA::ComponentMode> src() const { return Udm::AClassAssocAttr<AIF_CORBA::ModeTransition, AIF_CORBA::ComponentMode>(impl, meta_src, meta_src_rev); }

		static Uml::CompositionParentRole meta_ComponentInstance_parent;
		Udm::ParentAttr<AIF_CORBA::ComponentInstance> ComponentInstance_parent() const { return Udm::ParentAttr<AIF_CORBA::ComponentInstance>(impl, meta_ComponentInstance_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class ModeTransition :  public AIFObject {
	 public:
		static Uml::Class meta;

		ModeTransition() { }
		ModeTransition(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		ModeTransition(const ModeTransition &master) : AIFObject(master) { }
		static ModeTransition Cast(const Object &a) { return __Cast(a, meta); }

		static ModeTransition Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		ModeTransition CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		ModeTransition CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<ModeTransition> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::ModeTransition>(impl);}

		Udm::DerivedAttr<AIF_CORBA::ModeTransition> Derived() { return Udm::DerivedAttr<AIF_CORBA::ModeTransition>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::ModeTransition> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::ModeTransition>(impl);}

		static Uml::CompositionParentRole meta_ComponentInstance_parent;
		Udm::ParentAttr<AIF_CORBA::ComponentInstance> ComponentInstance_parent() const { return Udm::ParentAttr<AIF_CORBA::ComponentInstance>(impl, meta_ComponentInstance_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_src_end_;
		Udm::AssocEndAttr<AIF_CORBA::ComponentMode> src_end() const { return Udm::AssocEndAttr<AIF_CORBA::ComponentMode>(impl, meta_src_end_); }

		static Uml::AssociationRole meta_dst_end_;
		Udm::AssocEndAttr<AIF_CORBA::ComponentMode> dst_end() const { return Udm::AssocEndAttr<AIF_CORBA::ComponentMode>(impl, meta_dst_end_); }

	};

	class Interface :  public AIFObject {
	 public:
		static Uml::Class meta;

		Interface() { }
		Interface(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		Interface(const Interface &master) : AIFObject(master) { }
		static Interface Cast(const Object &a) { return __Cast(a, meta); }

		static Interface Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Interface CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Interface CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Interface> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::Interface>(impl);}

		Udm::DerivedAttr<AIF_CORBA::Interface> Derived() { return Udm::DerivedAttr<AIF_CORBA::Interface>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::Interface> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::Interface>(impl);}

		static Uml::AssociationRole meta_receptacles;
		Udm::AssocAttr<AIF_CORBA::Receptacle> receptacles() const { return Udm::AssocAttr<AIF_CORBA::Receptacle>(impl, meta_receptacles); }

		static Uml::AssociationRole meta_implementedBy;
		Udm::AssocAttr<AIF_CORBA::Facet> implementedBy() const { return Udm::AssocAttr<AIF_CORBA::Facet>(impl, meta_implementedBy); }

		static Uml::CompositionChildRole meta_Method_children;
		Udm::ChildrenAttr<AIF_CORBA::Method> Method_children() const { return Udm::ChildrenAttr<AIF_CORBA::Method>(impl, meta_Method_children); }

		Udm::ChildrenAttr<AIF_CORBA::Method> Method_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::Method>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::AIFObject> AIFObject_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_System_parent;
		Udm::ParentAttr<AIF_CORBA::System> System_parent() const { return Udm::ParentAttr<AIF_CORBA::System>(impl, meta_System_parent); }

		Udm::ParentAttr<AIF_CORBA::System> parent() const { return Udm::ParentAttr<AIF_CORBA::System>(impl, Udm::NULLPARENTROLE); }
	};

	class EventPort :  public AIFObject {
	 public:
		static Uml::Class meta;

		EventPort() { }
		EventPort(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		EventPort(const EventPort &master) : AIFObject(master) { }
		static EventPort Cast(const Object &a) { return __Cast(a, meta); }

		static EventPort Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		EventPort CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		EventPort CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<EventPort> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::EventPort>(impl);}

		Udm::DerivedAttr<AIF_CORBA::EventPort> Derived() { return Udm::DerivedAttr<AIF_CORBA::EventPort>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::EventPort> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::EventPort>(impl);}

		static Uml::CompositionParentRole meta_ComponentInstance_parent;
		Udm::ParentAttr<AIF_CORBA::ComponentInstance> ComponentInstance_parent() const { return Udm::ParentAttr<AIF_CORBA::ComponentInstance>(impl, meta_ComponentInstance_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class SubscribePort :  public EventPort {
	 public:
		static Uml::Class meta;

		SubscribePort() { }
		SubscribePort(Udm::ObjectImpl *impl) : EventPort(impl) { }
		SubscribePort(const SubscribePort &master) : EventPort(master) { }
		static SubscribePort Cast(const Object &a) { return __Cast(a, meta); }

		static SubscribePort Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		SubscribePort CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		SubscribePort CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<SubscribePort> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::SubscribePort>(impl);}

		Udm::DerivedAttr<AIF_CORBA::SubscribePort> Derived() { return Udm::DerivedAttr<AIF_CORBA::SubscribePort>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::SubscribePort> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::SubscribePort>(impl);}

		static Uml::Attribute meta_asynchronous;
		Udm::BooleanAttr asynchronous() const { return Udm::BooleanAttr(impl, meta_asynchronous); }

		static Uml::Attribute meta_correlation;
		Udm::BooleanAttr correlation() const { return Udm::BooleanAttr(impl, meta_correlation); }

		static Uml::AssociationRole meta_src;
		Udm::AssocAttr<AIF_CORBA::Event> src() const { return Udm::AssocAttr<AIF_CORBA::Event>(impl, meta_src); }

		static Uml::AssociationRole meta_action, meta_action_rev;
		Udm::AClassAssocAttr<AIF_CORBA::TriggerQoSProperties, AIF_CORBA::Action> action() const { return Udm::AClassAssocAttr<AIF_CORBA::TriggerQoSProperties, AIF_CORBA::Action>(impl, meta_action, meta_action_rev); }

		static Uml::AssociationRole meta_modes;
		Udm::AssocAttr<AIF_CORBA::ComponentMode> modes() const { return Udm::AssocAttr<AIF_CORBA::ComponentMode>(impl, meta_modes); }

		static Uml::AssociationRole meta_CommPort;
		Udm::PointerAttr<AIF_CORBA::CommPort> CommPort() const { return Udm::PointerAttr<AIF_CORBA::CommPort>(impl, meta_CommPort); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class PublishPort :  public EventPort {
	 public:
		static Uml::Class meta;

		PublishPort() { }
		PublishPort(Udm::ObjectImpl *impl) : EventPort(impl) { }
		PublishPort(const PublishPort &master) : EventPort(master) { }
		static PublishPort Cast(const Object &a) { return __Cast(a, meta); }

		static PublishPort Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		PublishPort CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		PublishPort CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<PublishPort> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::PublishPort>(impl);}

		Udm::DerivedAttr<AIF_CORBA::PublishPort> Derived() { return Udm::DerivedAttr<AIF_CORBA::PublishPort>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::PublishPort> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::PublishPort>(impl);}

		static Uml::AssociationRole meta_generatesEventsFor;
		Udm::AssocAttr<AIF_CORBA::Action> generatesEventsFor() const { return Udm::AssocAttr<AIF_CORBA::Action>(impl, meta_generatesEventsFor); }

		static Uml::AssociationRole meta_event;
		Udm::AssocAttr<AIF_CORBA::Event> event() const { return Udm::AssocAttr<AIF_CORBA::Event>(impl, meta_event); }

		static Uml::AssociationRole meta_modes;
		Udm::AssocAttr<AIF_CORBA::ComponentMode> modes() const { return Udm::AssocAttr<AIF_CORBA::ComponentMode>(impl, meta_modes); }

		static Uml::AssociationRole meta_CommPort;
		Udm::PointerAttr<AIF_CORBA::CommPort> CommPort() const { return Udm::PointerAttr<AIF_CORBA::CommPort>(impl, meta_CommPort); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class System :  public Object {
	 public:
		static Uml::Class meta;

		System() { }
		System(Udm::ObjectImpl *impl) : Object(impl) { }
		System(const System &master) : Object(master) { }
		static System Cast(const Object &a) { return __Cast(a, meta); }

		static System Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		System CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		System CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<System> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::System>(impl);}

		Udm::DerivedAttr<AIF_CORBA::System> Derived() { return Udm::DerivedAttr<AIF_CORBA::System>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::System> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::System>(impl);}

		static Uml::Attribute meta_timeUnit;
		Udm::StringAttr timeUnit() const { return Udm::StringAttr(impl, meta_timeUnit); }

		static Uml::CompositionChildRole meta_Interactions_children;
		Udm::ChildrenAttr<AIF_CORBA::Interactions> Interactions_children() const { return Udm::ChildrenAttr<AIF_CORBA::Interactions>(impl, meta_Interactions_children); }

		static Uml::CompositionChildRole meta_Network_children;
		Udm::ChildrenAttr<AIF_CORBA::Network> Network_children() const { return Udm::ChildrenAttr<AIF_CORBA::Network>(impl, meta_Network_children); }

		static Uml::CompositionChildRole meta_Interface_children;
		Udm::ChildrenAttr<AIF_CORBA::Interface> Interface_children() const { return Udm::ChildrenAttr<AIF_CORBA::Interface>(impl, meta_Interface_children); }

		Udm::ChildrenAttr<AIF_CORBA::Interactions> Interactions_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::Interactions>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::AIFObject> AIFObject_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::Interface> Interface_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::Interface>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::Network> Network_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::Network>(impl, Udm::NULLCHILDROLE); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class ApplicationComponent :  public ComponentInstance {
	 public:
		static Uml::Class meta;

		ApplicationComponent() { }
		ApplicationComponent(Udm::ObjectImpl *impl) : ComponentInstance(impl) { }
		ApplicationComponent(const ApplicationComponent &master) : ComponentInstance(master) { }
		static ApplicationComponent Cast(const Object &a) { return __Cast(a, meta); }

		static ApplicationComponent Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		ApplicationComponent CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		ApplicationComponent CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<ApplicationComponent> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::ApplicationComponent>(impl);}

		Udm::DerivedAttr<AIF_CORBA::ApplicationComponent> Derived() { return Udm::DerivedAttr<AIF_CORBA::ApplicationComponent>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::ApplicationComponent> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::ApplicationComponent>(impl);}

		static Uml::AssociationRole meta_proxy;
		Udm::AssocAttr<AIF_CORBA::SupportComponent> proxy() const { return Udm::AssocAttr<AIF_CORBA::SupportComponent>(impl, meta_proxy); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class Receptacle :  public AIFObject {
	 public:
		static Uml::Class meta;

		Receptacle() { }
		Receptacle(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		Receptacle(const Receptacle &master) : AIFObject(master) { }
		static Receptacle Cast(const Object &a) { return __Cast(a, meta); }

		static Receptacle Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Receptacle CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Receptacle CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Receptacle> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::Receptacle>(impl);}

		Udm::DerivedAttr<AIF_CORBA::Receptacle> Derived() { return Udm::DerivedAttr<AIF_CORBA::Receptacle>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::Receptacle> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::Receptacle>(impl);}

		static Uml::AssociationRole meta_co;
		Udm::AssocAttr<AIF_CORBA::CallOut> co() const { return Udm::AssocAttr<AIF_CORBA::CallOut>(impl, meta_co); }

		static Uml::AssociationRole meta_modes;
		Udm::AssocAttr<AIF_CORBA::ComponentMode> modes() const { return Udm::AssocAttr<AIF_CORBA::ComponentMode>(impl, meta_modes); }

		static Uml::AssociationRole meta_theInterface;
		Udm::PointerAttr<AIF_CORBA::Interface> theInterface() const { return Udm::PointerAttr<AIF_CORBA::Interface>(impl, meta_theInterface); }

		static Uml::AssociationRole meta_invokes, meta_invokes_rev;
		Udm::AClassAssocAttr<AIF_CORBA::InvocationConnection, AIF_CORBA::Facet> invokes() const { return Udm::AClassAssocAttr<AIF_CORBA::InvocationConnection, AIF_CORBA::Facet>(impl, meta_invokes, meta_invokes_rev); }

		static Uml::CompositionParentRole meta_ComponentInstance_parent;
		Udm::ParentAttr<AIF_CORBA::ComponentInstance> ComponentInstance_parent() const { return Udm::ParentAttr<AIF_CORBA::ComponentInstance>(impl, meta_ComponentInstance_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class SupportComponent :  public ComponentInstance {
	 public:
		static Uml::Class meta;

		SupportComponent() { }
		SupportComponent(Udm::ObjectImpl *impl) : ComponentInstance(impl) { }
		SupportComponent(const SupportComponent &master) : ComponentInstance(master) { }
		static SupportComponent Cast(const Object &a) { return __Cast(a, meta); }

		static SupportComponent Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		SupportComponent CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		SupportComponent CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<SupportComponent> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::SupportComponent>(impl);}

		Udm::DerivedAttr<AIF_CORBA::SupportComponent> Derived() { return Udm::DerivedAttr<AIF_CORBA::SupportComponent>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::SupportComponent> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::SupportComponent>(impl);}

		static Uml::AssociationRole meta_master;
		Udm::PointerAttr<AIF_CORBA::ApplicationComponent> master() const { return Udm::PointerAttr<AIF_CORBA::ApplicationComponent>(impl, meta_master); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class Facet :  public AIFObject {
	 public:
		static Uml::Class meta;

		Facet() { }
		Facet(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		Facet(const Facet &master) : AIFObject(master) { }
		static Facet Cast(const Object &a) { return __Cast(a, meta); }

		static Facet Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Facet CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Facet CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Facet> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::Facet>(impl);}

		Udm::DerivedAttr<AIF_CORBA::Facet> Derived() { return Udm::DerivedAttr<AIF_CORBA::Facet>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::Facet> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::Facet>(impl);}

		static Uml::Attribute meta_distributableWrite;
		Udm::BooleanAttr distributableWrite() const { return Udm::BooleanAttr(impl, meta_distributableWrite); }

		static Uml::Attribute meta_distributableRead;
		Udm::BooleanAttr distributableRead() const { return Udm::BooleanAttr(impl, meta_distributableRead); }

		static Uml::AssociationRole meta_iqos;
		Udm::AssocAttr<AIF_CORBA::InvocationQoSProperties> iqos() const { return Udm::AssocAttr<AIF_CORBA::InvocationQoSProperties>(impl, meta_iqos); }

		static Uml::AssociationRole meta_modes;
		Udm::PointerAttr<AIF_CORBA::ComponentMode> modes() const { return Udm::PointerAttr<AIF_CORBA::ComponentMode>(impl, meta_modes); }

		static Uml::AssociationRole meta_theInterface;
		Udm::PointerAttr<AIF_CORBA::Interface> theInterface() const { return Udm::PointerAttr<AIF_CORBA::Interface>(impl, meta_theInterface); }

		static Uml::AssociationRole meta_callout, meta_callout_rev;
		Udm::AClassAssocAttr<AIF_CORBA::InvocationConnection, AIF_CORBA::Receptacle> callout() const { return Udm::AClassAssocAttr<AIF_CORBA::InvocationConnection, AIF_CORBA::Receptacle>(impl, meta_callout, meta_callout_rev); }

		static Uml::CompositionParentRole meta_ComponentInstance_parent;
		Udm::ParentAttr<AIF_CORBA::ComponentInstance> ComponentInstance_parent() const { return Udm::ParentAttr<AIF_CORBA::ComponentInstance>(impl, meta_ComponentInstance_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class SystemMode :  public AIFObject {
	 public:
		static Uml::Class meta;

		SystemMode() { }
		SystemMode(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		SystemMode(const SystemMode &master) : AIFObject(master) { }
		static SystemMode Cast(const Object &a) { return __Cast(a, meta); }

		static SystemMode Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		SystemMode CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		SystemMode CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<SystemMode> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::SystemMode>(impl);}

		Udm::DerivedAttr<AIF_CORBA::SystemMode> Derived() { return Udm::DerivedAttr<AIF_CORBA::SystemMode>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::SystemMode> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::SystemMode>(impl);}

		static Uml::Attribute meta_faultMode;
		Udm::BooleanAttr faultMode() const { return Udm::BooleanAttr(impl, meta_faultMode); }

		static Uml::AssociationRole meta_Interactions;
		Udm::PointerAttr<AIF_CORBA::Interactions> Interactions() const { return Udm::PointerAttr<AIF_CORBA::Interactions>(impl, meta_Interactions); }

		static Uml::CompositionParentRole meta_Processor_parent;
		Udm::ParentAttr<AIF_CORBA::Processor> Processor_parent() const { return Udm::ParentAttr<AIF_CORBA::Processor>(impl, meta_Processor_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class Component :  public AIFObject {
	 public:
		static Uml::Class meta;

		Component() { }
		Component(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		Component(const Component &master) : AIFObject(master) { }
		static Component Cast(const Object &a) { return __Cast(a, meta); }

		static Component Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Component CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Component CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Component> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::Component>(impl);}

		Udm::DerivedAttr<AIF_CORBA::Component> Derived() { return Udm::DerivedAttr<AIF_CORBA::Component>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::Component> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::Component>(impl);}

		static Uml::CompositionParentRole meta_Process_parent;
		Udm::ParentAttr<AIF_CORBA::Process> Process_parent() const { return Udm::ParentAttr<AIF_CORBA::Process>(impl, meta_Process_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_dst_end_;
		Udm::AssocEndAttr<AIF_CORBA::ComponentInstance> dst_end() const { return Udm::AssocEndAttr<AIF_CORBA::ComponentInstance>(impl, meta_dst_end_); }

		static Uml::AssociationRole meta_owner_end_;
		Udm::AssocEndAttr<AIF_CORBA::Process> owner_end() const { return Udm::AssocEndAttr<AIF_CORBA::Process>(impl, meta_owner_end_); }

	};

	class BackupComponent :  public Component {
	 public:
		static Uml::Class meta;

		BackupComponent() { }
		BackupComponent(Udm::ObjectImpl *impl) : Component(impl) { }
		BackupComponent(const BackupComponent &master) : Component(master) { }
		static BackupComponent Cast(const Object &a) { return __Cast(a, meta); }

		static BackupComponent Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		BackupComponent CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		BackupComponent CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<BackupComponent> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::BackupComponent>(impl);}

		Udm::DerivedAttr<AIF_CORBA::BackupComponent> Derived() { return Udm::DerivedAttr<AIF_CORBA::BackupComponent>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::BackupComponent> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::BackupComponent>(impl);}

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class Processor :  public AIFObject {
	 public:
		static Uml::Class meta;

		Processor() { }
		Processor(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		Processor(const Processor &master) : AIFObject(master) { }
		static Processor Cast(const Object &a) { return __Cast(a, meta); }

		static Processor Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Processor CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Processor CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Processor> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::Processor>(impl);}

		Udm::DerivedAttr<AIF_CORBA::Processor> Derived() { return Udm::DerivedAttr<AIF_CORBA::Processor>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::Processor> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::Processor>(impl);}

		static Uml::Attribute meta_id;
		Udm::IntegerAttr id() const { return Udm::IntegerAttr(impl, meta_id); }

		static Uml::CompositionChildRole meta_Process_children;
		Udm::ChildrenAttr<AIF_CORBA::Process> Process_children() const { return Udm::ChildrenAttr<AIF_CORBA::Process>(impl, meta_Process_children); }

		static Uml::CompositionChildRole meta_ComponentInstance_children;
		Udm::ChildrenAttr<AIF_CORBA::ComponentInstance> ComponentInstance_children() const { return Udm::ChildrenAttr<AIF_CORBA::ComponentInstance>(impl, meta_ComponentInstance_children); }

		static Uml::CompositionChildRole meta_SystemMode_children;
		Udm::ChildrenAttr<AIF_CORBA::SystemMode> SystemMode_children() const { return Udm::ChildrenAttr<AIF_CORBA::SystemMode>(impl, meta_SystemMode_children); }

		static Uml::CompositionChildRole meta_CommPort_children;
		Udm::ChildrenAttr<AIF_CORBA::CommPort> CommPort_children() const { return Udm::ChildrenAttr<AIF_CORBA::CommPort>(impl, meta_CommPort_children); }

		Udm::ChildrenAttr<AIF_CORBA::AIFObject> AIFObject_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::ComponentInstance> ComponentInstance_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::ComponentInstance>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::ApplicationComponent> ApplicationComponent_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::ApplicationComponent>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::SupportComponent> SupportComponent_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::SupportComponent>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::SystemMode> SystemMode_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::SystemMode>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::CommPort> CommPort_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::CommPort>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::Process> Process_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::Process>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_Network_parent;
		Udm::ParentAttr<AIF_CORBA::Network> Network_parent() const { return Udm::ParentAttr<AIF_CORBA::Network>(impl, meta_Network_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class CommPort :  public AIFObject {
	 public:
		static Uml::Class meta;

		CommPort() { }
		CommPort(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		CommPort(const CommPort &master) : AIFObject(master) { }
		static CommPort Cast(const Object &a) { return __Cast(a, meta); }

		static CommPort Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		CommPort CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		CommPort CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<CommPort> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::CommPort>(impl);}

		Udm::DerivedAttr<AIF_CORBA::CommPort> Derived() { return Udm::DerivedAttr<AIF_CORBA::CommPort>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::CommPort> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::CommPort>(impl);}

		static Uml::AssociationRole meta_subscriber;
		Udm::AssocAttr<AIF_CORBA::SubscribePort> subscriber() const { return Udm::AssocAttr<AIF_CORBA::SubscribePort>(impl, meta_subscriber); }

		static Uml::AssociationRole meta_publisher;
		Udm::AssocAttr<AIF_CORBA::PublishPort> publisher() const { return Udm::AssocAttr<AIF_CORBA::PublishPort>(impl, meta_publisher); }

		static Uml::AssociationRole meta_dst, meta_dst_rev;
		Udm::AClassAssocAttr<AIF_CORBA::Link, AIF_CORBA::CommPort> dst() const { return Udm::AClassAssocAttr<AIF_CORBA::Link, AIF_CORBA::CommPort>(impl, meta_dst, meta_dst_rev); }

		static Uml::AssociationRole meta_src, meta_src_rev;
		Udm::AClassAssocAttr<AIF_CORBA::Link, AIF_CORBA::CommPort> src() const { return Udm::AClassAssocAttr<AIF_CORBA::Link, AIF_CORBA::CommPort>(impl, meta_src, meta_src_rev); }

		static Uml::CompositionParentRole meta_Processor_parent;
		Udm::ParentAttr<AIF_CORBA::Processor> Processor_parent() const { return Udm::ParentAttr<AIF_CORBA::Processor>(impl, meta_Processor_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class Link :  public AIFObject {
	 public:
		static Uml::Class meta;

		Link() { }
		Link(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		Link(const Link &master) : AIFObject(master) { }
		static Link Cast(const Object &a) { return __Cast(a, meta); }

		static Link Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Link CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Link CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Link> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::Link>(impl);}

		Udm::DerivedAttr<AIF_CORBA::Link> Derived() { return Udm::DerivedAttr<AIF_CORBA::Link>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::Link> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::Link>(impl);}

		static Uml::AssociationRole meta_invocationConns;
		Udm::AssocAttr<AIF_CORBA::InvocationConnection> invocationConns() const { return Udm::AssocAttr<AIF_CORBA::InvocationConnection>(impl, meta_invocationConns); }

		static Uml::CompositionParentRole meta_Network_parent;
		Udm::ParentAttr<AIF_CORBA::Network> Network_parent() const { return Udm::ParentAttr<AIF_CORBA::Network>(impl, meta_Network_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_src_end_;
		Udm::AssocEndAttr<AIF_CORBA::CommPort> src_end() const { return Udm::AssocEndAttr<AIF_CORBA::CommPort>(impl, meta_src_end_); }

		static Uml::AssociationRole meta_dst_end_;
		Udm::AssocEndAttr<AIF_CORBA::CommPort> dst_end() const { return Udm::AssocEndAttr<AIF_CORBA::CommPort>(impl, meta_dst_end_); }

	};

	class Process :  public AIFObject {
	 public:
		static Uml::Class meta;

		Process() { }
		Process(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		Process(const Process &master) : AIFObject(master) { }
		static Process Cast(const Object &a) { return __Cast(a, meta); }

		static Process Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Process CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Process CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Process> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::Process>(impl);}

		Udm::DerivedAttr<AIF_CORBA::Process> Derived() { return Udm::DerivedAttr<AIF_CORBA::Process>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::Process> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::Process>(impl);}

		static Uml::AssociationRole meta_dst, meta_dst_rev;
		Udm::AClassAssocAttr<AIF_CORBA::Component, AIF_CORBA::ComponentInstance> dst() const { return Udm::AClassAssocAttr<AIF_CORBA::Component, AIF_CORBA::ComponentInstance>(impl, meta_dst, meta_dst_rev); }

		static Uml::CompositionChildRole meta_Component_children;
		Udm::ChildrenAttr<AIF_CORBA::Component> Component_children() const { return Udm::ChildrenAttr<AIF_CORBA::Component>(impl, meta_Component_children); }

		static Uml::CompositionChildRole meta_Thread_children;
		Udm::ChildrenAttr<AIF_CORBA::Thread> Thread_children() const { return Udm::ChildrenAttr<AIF_CORBA::Thread>(impl, meta_Thread_children); }

		Udm::ChildrenAttr<AIF_CORBA::AIFObject> AIFObject_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::BackupComponent> BackupComponent_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::BackupComponent>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::Component> Component_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::Component>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::Thread> Thread_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::Thread>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::NormalComponent> NormalComponent_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::NormalComponent>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_Processor_parent;
		Udm::ParentAttr<AIF_CORBA::Processor> Processor_parent() const { return Udm::ParentAttr<AIF_CORBA::Processor>(impl, meta_Processor_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class Thread :  public AIFObject {
	 public:
		static Uml::Class meta;

		Thread() { }
		Thread(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		Thread(const Thread &master) : AIFObject(master) { }
		static Thread Cast(const Object &a) { return __Cast(a, meta); }

		static Thread Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Thread CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Thread CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Thread> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::Thread>(impl);}

		Udm::DerivedAttr<AIF_CORBA::Thread> Derived() { return Udm::DerivedAttr<AIF_CORBA::Thread>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::Thread> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::Thread>(impl);}

		static Uml::AssociationRole meta_iQoSProp;
		Udm::AssocAttr<AIF_CORBA::InvocationQoSProperties> iQoSProp() const { return Udm::AssocAttr<AIF_CORBA::InvocationQoSProperties>(impl, meta_iQoSProp); }

		static Uml::AssociationRole meta_tQoSProp;
		Udm::AssocAttr<AIF_CORBA::TriggerQoSProperties> tQoSProp() const { return Udm::AssocAttr<AIF_CORBA::TriggerQoSProperties>(impl, meta_tQoSProp); }

		static Uml::CompositionParentRole meta_Process_parent;
		Udm::ParentAttr<AIF_CORBA::Process> Process_parent() const { return Udm::ParentAttr<AIF_CORBA::Process>(impl, meta_Process_parent); }

		Udm::ParentAttr<AIF_CORBA::AIFObject> parent() const { return Udm::ParentAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class NormalComponent :  public Component {
	 public:
		static Uml::Class meta;

		NormalComponent() { }
		NormalComponent(Udm::ObjectImpl *impl) : Component(impl) { }
		NormalComponent(const NormalComponent &master) : Component(master) { }
		static NormalComponent Cast(const Object &a) { return __Cast(a, meta); }

		static NormalComponent Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		NormalComponent CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		NormalComponent CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<NormalComponent> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::NormalComponent>(impl);}

		Udm::DerivedAttr<AIF_CORBA::NormalComponent> Derived() { return Udm::DerivedAttr<AIF_CORBA::NormalComponent>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::NormalComponent> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::NormalComponent>(impl);}

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class Network :  public AIFObject {
	 public:
		static Uml::Class meta;

		Network() { }
		Network(Udm::ObjectImpl *impl) : AIFObject(impl) { }
		Network(const Network &master) : AIFObject(master) { }
		static Network Cast(const Object &a) { return __Cast(a, meta); }

		static Network Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Network CreateInstance(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Network CreateDerived(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Network> Instances() { return Udm::InstantiatedAttr<AIF_CORBA::Network>(impl);}

		Udm::DerivedAttr<AIF_CORBA::Network> Derived() { return Udm::DerivedAttr<AIF_CORBA::Network>(impl);}

		Udm::ArchetypeAttr<AIF_CORBA::Network> Archetype() { return Udm::ArchetypeAttr<AIF_CORBA::Network>(impl);}

		static Uml::CompositionChildRole meta_Processor_children;
		Udm::ChildrenAttr<AIF_CORBA::Processor> Processor_children() const { return Udm::ChildrenAttr<AIF_CORBA::Processor>(impl, meta_Processor_children); }

		static Uml::CompositionChildRole meta_Link_children;
		Udm::ChildrenAttr<AIF_CORBA::Link> Link_children() const { return Udm::ChildrenAttr<AIF_CORBA::Link>(impl, meta_Link_children); }

		Udm::ChildrenAttr<AIF_CORBA::AIFObject> AIFObject_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::AIFObject>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::Processor> Processor_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::Processor>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<AIF_CORBA::Link> Link_kind_children() const { return Udm::ChildrenAttr<AIF_CORBA::Link>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_System_parent;
		Udm::ParentAttr<AIF_CORBA::System> System_parent() const { return Udm::ParentAttr<AIF_CORBA::System>(impl, meta_System_parent); }

		Udm::ParentAttr<AIF_CORBA::System> parent() const { return Udm::ParentAttr<AIF_CORBA::System>(impl, Udm::NULLPARENTROLE); }
	};

}

#endif //MOBIES_AIF_H
