// MyTreeView.cpp : implementation file
//

#include "stdafx.h"
#include "Avionics.h"
#include "MyTreeView.h"
#include "AvionicsDoc.h"
#include "AIFRead.h"
#include "CPUMappingDlg.h"
#include "WarningReportDlg.h"
#include "TaskPlotDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyTreeView CTreeCtrl

IMPLEMENT_DYNCREATE(CMyTreeView, CTreeView)

CMyTreeView::CMyTreeView()
{
}

CMyTreeView::~CMyTreeView()
{
}


BEGIN_MESSAGE_MAP(CMyTreeView, CTreeView)
	//{{AFX_MSG_MAP(CMyTreeView)
	ON_WM_CREATE()
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, OnSelchanged)
	ON_COMMAND(ID_FORWARD_REACHABLE, OnForwardReachable)
	ON_COMMAND(ID_BACKWARD_REACHABLE, OnBackwardReachable)
	ON_COMMAND(ID_VIEW_WARNING_REPORT, OnViewWarningReport)
	ON_NOTIFY_REFLECT(NM_RCLICK, OnRclick)
	ON_WM_INITMENUPOPUP()
	ON_COMMAND(IDR_MENU_COMP_BSLICE, OnMenuCompBslice)
	ON_COMMAND(IDR_MENU_COMP_FSLICE, OnMenuCompFslice)
	ON_COMMAND(IDR_MENU_PORT_BSLICE, OnMenuPortBslice)
	ON_COMMAND(IDR_MENU_PORT_FSLICE, OnMenuPortFslice)
	ON_UPDATE_COMMAND_UI(ID_FORWARD_REACHABLE, OnUpdateForwardReachable)
	ON_UPDATE_COMMAND_UI(ID_BACKWARD_REACHABLE, OnUpdateBackwardReachable)
	ON_UPDATE_COMMAND_UI(ID_VIEW_COMP_GRAPH, OnUpdateViewCompGraph)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PEDG, OnUpdateViewPedg)
	ON_UPDATE_COMMAND_UI(ID_VIEW_WARNING_REPORT, OnUpdateViewWarningReport)
	ON_COMMAND(ID_VIEW_COMPSLICE, OnViewCompslice)
	ON_COMMAND(ID_VIEW_PORT_SLICE, OnViewPortSlice)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PORT_SLICE, OnUpdateViewPortSlice)
	ON_UPDATE_COMMAND_UI(ID_VIEW_COMPSLICE, OnUpdateViewCompslice)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyTreeView drawing

void CMyTreeView::OnDraw(CDC* pDC)
{
	//CAvionicsDoc* pDoc = (CAvionicsDoc *)GetDocument();
	Populate();
	//pDoc->ListView->DisplayProcessors();
}

/////////////////////////////////////////////////////////////////////////////
// CMyTreeView diagnostics

#ifdef _DEBUG
void CMyTreeView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CMyTreeView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMyTreeView message handlers

int CMyTreeView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	lpCreateStruct->style |= ( TVS_HASLINES | TVS_HASBUTTONS | TVS_LINESATROOT );

	if ( CTreeView::OnCreate( lpCreateStruct ) == (-1) )
	{
	   return( -1 );
	}

	CAvionicsDoc * document_p = (CAvionicsDoc *)GetDocument();

	ASSERT( document_p != NULL );

	document_p->TreeView = this;

	ImageList.Create( IDB_IMAGELIST, 16, 0, RGB( 255, 0, 255 ) );
	ImageList.SetBkColor( GetSysColor( COLOR_WINDOW ) );

	CTreeCtrl& tree_control = GetTreeCtrl();

	tree_control.SetImageList( &ImageList, TVSIL_NORMAL );

	UpdateWindow();

	RootItem = tree_control.InsertItem( "Component View", IMAGE_ROOT, IMAGE_ROOT_SEL);
	RootItem2 = tree_control.InsertItem( "Task View", IMAGE_TILE_5, IMAGE_TILE_5_SEL);
//	Populate();
	return( 0 );
}

void CMyTreeView::DeleteChildren( HTREEITEM parent_item )
{
   CTreeCtrl& tree_control = GetTreeCtrl();

   HTREEITEM child_item = (HTREEITEM) NULL;

   child_item = tree_control.GetChildItem( parent_item );

   while( child_item != NULL )
   {
      tree_control.DeleteItem( child_item );
      child_item = tree_control.GetChildItem( parent_item );
   }
}

DWORD CMyTreeView::ImageToWhatItIs( DWORD image_id ) const
{
   switch( image_id )
   {
      case IMAGE_ROOT:

         return( IT_IS_THE_ROOT );

      case IMAGE_TILE_2:

         return( IT_IS_AN_XML_DOCUMENT );

      case IMAGE_TILE_3:

         return( IT_IS_AN_ELEMENT );

      default:

         return( 0 );
   }
}

/*
void AddDevices(set<ElectricDevice> &devs, HTREEITEM pos, CTreeCtrl& m_tree) {
	for(set<ElectricDevice>::iterator ii = devs.begin();
		ii != devs.end(); ii++) {
					HTREEITEM ht = m_tree.InsertItem(
						string(ii->name()).c_str(), 
						0, 0, pos);
					m_tree.SetItemData(ht, ii->uniqueId());
					if(ii->type() == Lamp::meta) {
						set<ElectricDevice> s = Lamp::Cast(*ii).ElectricDevice_kind_children();
						AddDevices( s, ht, m_tree);
					}
		}
}

void CMyTreeView::Populate(const RootFolder& rrr) {
	DeleteChildren ( RootItem );
	CTreeCtrl& tree_control = GetTreeCtrl();
	HTREEITEM item_level1, item_level2;
	AddDevices(set<ElectricDevice>(rrr.ElectricDevice_kind_children()) , RootItem, tree_control);	
}
*/

#if 0
void CMyTreeView::Populate() {
	DeleteChildren( RootItem);
	DeleteChildren( RootItem2);
	CTreeCtrl& tree_control = GetTreeCtrl();
	tree_control.SelectItem(RootItem);
	HTREEITEM item_level1, item_level2, item_level3;
	
    //item_level1 = tree_control.InsertItem( TEXT( "XML1" ), IMAGE_TILE_2, IMAGE_TILE_2, RootItem );
	//tree_control.SetItemData( document_item, (DWORD) xml_p );
	//item_level2 = tree_control.InsertItem( TEXT( "XML2" ), IMAGE_TILE_3, IMAGE_TILE_3, item_level1 );
	/*set<Network> networks = system.Network_kind_children();
	for(set<Network>::iterator ii = networks.begin(); ii != networks.end(); ii++) {
		//AfxMessageBox((const char*)(ii->name()));
		set<Processor> procs = Network::Cast(*ii).Processor_kind_children();
		for(set<Processor>::iterator ii2 = procs.begin(); ii2 != procs.end(); ii2++) {
			tree_control.InsertItem(string(ii2->name()).c_str(), IMAGE_TILE_2, IMAGE_TILE_2, RootItem );
		
		}
	}*/
	//ASSERT(gCurrentMode == NORMAL);
	//ASSERT(gProcessorNodeList.GetCount() == 1);

	POSITION pos = gTheSystem.processorNodeList.GetHeadPosition();
	while(pos) {
		CProcessorNode *pNode = gTheSystem.processorNodeList.GetNext(pos);
		item_level1 = tree_control.InsertItem(pNode->name, IMAGE_TILE_2, IMAGE_TILE_2_SEL, RootItem);
		tree_control.SetItemData(item_level1, (DWORD) pNode);

		POSITION pos2 = pNode->components.GetHeadPosition();
		while(pos2) {
			CComponentNode *cNode = pNode->components.GetNext(pos2);
			item_level2 = tree_control.InsertItem(cNode->name, IMAGE_TILE_3, IMAGE_TILE_3_SEL, item_level1);
			tree_control.SetItemData(item_level2, (DWORD) cNode);

			POSITION pos3 = cNode->ports.GetHeadPosition();
			while(pos3) {
				CPortNode *portNode = cNode->ports.GetNext(pos3);
				item_level3 = tree_control.InsertItem(portNode->GetName(), IMAGE_TILE_4, IMAGE_TILE_4_SEL, item_level2);
				tree_control.SetItemData(item_level3, (DWORD) portNode);
			}
		}
	}

	pos = gTheSystem.processorNodeList.GetHeadPosition();
	while(pos) {
		CProcessorNode *pNode = gTheSystem.processorNodeList.GetNext(pos);
		item_level1 = tree_control.InsertItem(pNode->name, IMAGE_TILE_6, IMAGE_TILE_6_SEL, RootItem2);
		tree_control.SetItemData(item_level1, (DWORD) pNode);

		for(int i = 0; i < NUM_RATES; i++) {
			CTaskNode *tNode = &pNode->tasks[i];
			//if(tNode->wcet == 0) continue;
			//If a task doesnot contain any ports, skip over it.
//			if(tNode->ports.GetCount() == 0) continue;
			item_level2 = tree_control.InsertItem(tNode->GetName(),
				IMAGE_TILE_7, IMAGE_TILE_7_SEL, item_level1);
			tree_control.SetItemData(item_level2, (DWORD) tNode);		
			
			POSITION pos3 = tNode->ports.GetHeadPosition();
			while(pos3) {
				CPortNode *portNode = tNode->ports.GetNext(pos3);
				ASSERT(portNode->parentTask);
				if(portNode->type != SUBSCRIBEPORT && portNode->type != FACET) continue;
				CComponentNode *cNode = portNode->parentComp;
				item_level3 = tree_control.InsertItem(cNode->name + "." + portNode->GetName(), IMAGE_TILE_8, IMAGE_TILE_8_SEL, item_level2);
				tree_control.SetItemData(item_level3, (DWORD) portNode);
			}
		}
	}
	SortRecursive(RootItem);
	SortRecursive(RootItem2);
}
#endif
#if 1
void CMyTreeView::Populate() {
	DeleteChildren( RootItem);
	DeleteChildren( RootItem2);
	CTreeCtrl& tree_control = GetTreeCtrl();
	HTREEITEM item_level1, item_level2, item_level3;

	POSITION pos = gTheSystem.processorNodeList.GetTailPosition();
	//POSITION pos = gTheSystem.processorNodeList.GetHeadPosition();
	while(pos) {
		//CProcessorNode *pNode = gTheSystem.processorNodeList.GetNext(pos);
		CProcessorNode *pNode = gTheSystem.processorNodeList.GetPrev(pos);
		item_level1 = tree_control.InsertItem(pNode->name, IMAGE_TILE_2, IMAGE_TILE_2_SEL, RootItem);
		tree_control.SetItemData(item_level1, (DWORD) pNode);

		POSITION pos2 = pNode->components.GetHeadPosition();
		while(pos2) {
			CComponentNode *cNode = pNode->components.GetNext(pos2);
			item_level2 = tree_control.InsertItem(cNode->name, IMAGE_TILE_3, IMAGE_TILE_3_SEL, item_level1);
			tree_control.SetItemData(item_level2, (DWORD) cNode);
			POSITION pos3 = cNode->ports.GetHeadPosition();
			while(pos3) {
				CPortNode *portNode = cNode->ports.GetNext(pos3);
				vertex v = portNode->index;
				ASSERT(v != 0 && v != -1);
				if(portNode->type == PUBLISHPORT || portNode->type == RECEPTACLE) {
					edge e = gTheSystem.thePEDG.firstout(v);
					while(e) {
						CString str = portNode->GetName() + ">";
						item_level3 = tree_control.InsertItem(str, IMAGE_TILE_4, IMAGE_TILE_4_SEL, item_level2);
						tree_control.SetItemData(item_level3, (DWORD) portNode);

/*						edge_type_t type = gTheSystem.thePEDG.get_edge_type(e);
						CString name = gTheSystem.thePEDG.get_edge_name(e);
						vertex v2 = gTheSystem.thePEDG.head(e);
						CString nodename = gTheSystem.thePEDG.get_node_name(v2);*/
						e = gTheSystem.thePEDG.nextout(e);
					}
				} else {
					edge e = gTheSystem.thePEDG.firstin(v);
					while(e) {
						CString str = ">" + portNode->GetName();
						item_level3 = tree_control.InsertItem(str, IMAGE_TILE_4, IMAGE_TILE_4_SEL, item_level2);
						tree_control.SetItemData(item_level3, (DWORD) portNode);
						e = gTheSystem.thePEDG.nextin(e);
					}
				}
			}
		}
		//break; HACK RTSS
	}

	pos = gTheSystem.processorNodeList.GetTailPosition();
	//pos = gTheSystem.processorNodeList.GetHeadPosition();
	while(pos) {
		//CProcessorNode *pNode = gTheSystem.processorNodeList.GetNext(pos);
		CProcessorNode *pNode = gTheSystem.processorNodeList.GetPrev(pos);
		item_level1 = tree_control.InsertItem(pNode->name, IMAGE_TILE_6, IMAGE_TILE_6_SEL, RootItem2);
		tree_control.SetItemData(item_level1, (DWORD) pNode);

		for(int i = 0; i < NUM_RATES; i++) {
			CTaskNode *tNode = &pNode->tasks[i];
			//if(tNode->wcet == 0) continue;
			//If a task doesnot contain any ports, skip over it.
			if(tNode->ports.GetCount() == 0) continue;
			item_level2 = tree_control.InsertItem(tNode->GetName(),
				IMAGE_TILE_7, IMAGE_TILE_7_SEL, item_level1);
			tree_control.SetItemData(item_level2, (DWORD) tNode);		
			
			POSITION pos3 = tNode->ports.GetHeadPosition();
			while(pos3) {
				CPortNode *portNode = tNode->ports.GetNext(pos3);
				ASSERT(portNode->parentTask);
				if(portNode->type != SUBSCRIBEPORT && portNode->type != FACET) continue;
				CComponentNode *cNode = portNode->parentComp;
				item_level3 = tree_control.InsertItem(cNode->name + "." + portNode->GetName(), IMAGE_TILE_8, IMAGE_TILE_8_SEL, item_level2);
				tree_control.SetItemData(item_level3, (DWORD) portNode);
			}
		}
		//break; HACK RTSS
	}
	SortRecursive(RootItem);
	SortRecursive(RootItem2);
	tree_control.SelectItem(RootItem);
	CAvionicsDoc* pDoc = (CAvionicsDoc *)GetDocument();
	pDoc->ListView->DisplayProcessors();
}
#endif
void CMyTreeView::SortRecursive(HTREEITEM hItem) {
	CTreeCtrl& tree_control = GetTreeCtrl();
	if (tree_control.ItemHasChildren(hItem))
	{
		tree_control.SortChildren(hItem);
	    HTREEITEM hChildItem = tree_control.GetChildItem(hItem);

	    while (hChildItem != NULL)
		{
		   SortRecursive(hChildItem);
		   hChildItem = tree_control.GetNextItem(hChildItem, TVGN_NEXT);
		}
	}
}

void CMyTreeView::OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CAvionicsDoc* pDoc = (CAvionicsDoc *)GetDocument();
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	TVITEM		newItem = pNMTreeView->itemNew;
	CTreeCtrl& tree_control = GetTreeCtrl();
	if (newItem.mask & TVIF_HANDLE) {
		int image, selectedImage;
		tree_control.GetItemImage(newItem.hItem, image, selectedImage);
		CProcessorNode *pNode;
		CComponentNode *cNode;
		CTaskNode *tNode;
		switch(image) {

			case IMAGE_ROOT: 
				pDoc->ListView->DisplayProcessors();
				break;
			case IMAGE_TILE_2:
				pNode = (CProcessorNode *) tree_control.GetItemData(newItem.hItem);
				pDoc->ListView->DisplayComponents(pNode);
				break;
			case IMAGE_TILE_3:
				cNode = (CComponentNode *) tree_control.GetItemData(newItem.hItem);
				pDoc->ListView->DisplayComponentDetails(cNode);
				break;
			case IMAGE_TILE_4:
				pDoc->ListView->DisplayPortDetails((CPortNode *) tree_control.GetItemData(newItem.hItem));
				break; 

			case IMAGE_TILE_5: 
				pDoc->ListView->DisplayProcessors();
				break;
			case IMAGE_TILE_6:
				pNode = (CProcessorNode *) tree_control.GetItemData(newItem.hItem);
				pDoc->ListView->DisplayTasks(pNode);
				break;
			case IMAGE_TILE_7:
				tNode = (CTaskNode *) tree_control.GetItemData(newItem.hItem);
				pDoc->ListView->DisplayComponentPorts(tNode->ports);
				break;
			case IMAGE_TILE_8:
				pDoc->ListView->DisplayPortDetails((CPortNode *) tree_control.GetItemData(newItem.hItem));
				break;
			default:
				ASSERT(0);
		}
		pDoc->ListView->SortColumnAscending(0);
	}
	*pResult = 0;
}

/*
void CMyTreeView::OnViewReserveProfile() 
{
#if 0
	HTREEITEM item = GetTreeCtrl().GetSelectedItem();
	ASSERT(item);
	int nImage, nSelectedImage;
	GetTreeCtrl().GetItemImage(item, nImage, nSelectedImage);
	if(nImage != IMAGE_TILE_2) {
		AfxMessageBox("Please select a CPU processor item to view its reserve profile. ");
		return;
	}

	CProcessorNode *pNode = (CProcessorNode *) GetTreeCtrl().GetItemData(item);

	int numTasks = pNode->taskNodeList.GetCount();
	CString cs;
	for(int i = 0; i < numTasks; i++) {
		
		for(int x = 0; x < numTasks; x++) {
			CString temp;
			temp.Format("%lf  ", pNode->reserveProfileTable[x][i]);
			cs += temp;
		}
		cs += "\n";
	}
	AfxMessageBox(cs);
#endif
}

*/

/*  Obsolete code using a tcl script to display e2e timeline.
	FILE *dat = fopen("c:\\temp\\mobies.dat", "w");
	ASSERT(dat);

	POSITION pos = tChain->taskNodeList.GetHeadPosition();
	while(pos) {
		CTaskNode *taskNode = tChain->taskNodeList.GetNext(pos);
		fprintf(dat, "%s ", taskNode->name);
		fprintf(dat, "%d ", taskNode->deadline);
		fprintf(dat, "%.2lf ", taskNode->wcrt);
		fprintf(dat, "%.2lf\n", taskNode->wcrt - taskNode->bcrt);
	}
	//PrintTaskNode(dat, taskNode);
	fclose(dat);
	system("wish83 c:\\temp\\e2e.tcl");
*/

/*
void PrintTaskNode(FILE *dat, CTaskNode *taskNode) {
	fprintf(dat, "%s ", taskNode->name);
	fprintf(dat, "%d ", taskNode->deadline);
	fprintf(dat, "%.2lf ", taskNode->wcrt);
	fprintf(dat, "%.2lf\n", taskNode->wcet);

	POSITION pos = taskNode->adjList.GetHeadPosition();
	if(!pos) return;
	while(pos) {
		PrintTaskNode(dat, taskNode->adjList.GetNext(pos));
	}
}
*/

//This does not work very well. I need to get the cursor position instead of
//the selected item.
/*
void CMyTreeView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
#if 1
	CTreeCtrl &tree_control = GetTreeCtrl();
	HTREEITEM item = tree_control.GetSelectedItem();
	int nImage, nSelectedImage;
	tree_control.GetItemImage(item, nImage, nSelectedImage);
	if(1) {
	//	if(nImage = IMAGE_TILE_6) {
		CMenu menu;
		menu.LoadMenu(IDR_POPUP);
		menu.GetSubMenu(0)->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
							point.x,point.y,GetParent());
	}
#endif
}
*/

void CMyTreeView::OnForwardReachable() 
{
	HTREEITEM item = GetTreeCtrl().GetSelectedItem();
	ASSERT(item);
	int nImage, nSelectedImage;
	GetTreeCtrl().GetItemImage(item, nImage, nSelectedImage);
	if (!(nImage == IMAGE_TILE_4 || nImage == IMAGE_TILE_3 || nImage == IMAGE_TILE_8)) {
		AfxMessageBox("Please select a component or port to view its forward slice.");
		return;
	}

	const char *dottyFileName = "c:\\temp\\fwdreach.dot";
	FILE *f = fopen(dottyFileName, "w");
	ASSERT(f);
	if(nImage == IMAGE_TILE_3) {
		CComponentNode *cNode = (CComponentNode *) GetTreeCtrl().GetItemData(item);
		fprintf(f, "digraph G { \n label=\"type: Forward Slice from %s\";\n",
			 cNode->name); 
		fprintf(f, "size=\"7.5,10\"\n");
		fprintf(f, "page=\"8.5,11\"\n");
		fprintf(f, "nodesep=0.1\n");
		fprintf(f, "node [shape=box,height=.2,width=.1,fontname=Tahoma]\n");
		gTheSystem.theCEDG.reset_color();
		gTheSystem.theCEDG.DFSForwardSlice(cNode->index, f);
	} else if(nImage == IMAGE_TILE_4 || nImage == IMAGE_TILE_8) {
		CPortNode *pNode = (CPortNode *) GetTreeCtrl().GetItemData(item);
		fprintf(f, "digraph G { \n label=\"type: Forward Slice from %s\";\n",
			 pNode->GetName()); 
		fprintf(f, "size=\"7.5,10\"\n");
		fprintf(f, "page=\"8.5,11\"\n");
		fprintf(f, "nodesep=0.1\n");
		fprintf(f, "node [shape=box,height=.2,width=.1,fontname=Tahoma]\n");

		gTheSystem.thePEDG.reset_color();
		gTheSystem.thePEDG.DFSForwardSlice(pNode->index, f);
	}

	fprintf(f, "}\n;");
	fclose(f);
	CString command = "dotty " + CString(dottyFileName);
	system(command);
}

void CMyTreeView::OnBackwardReachable() 
{
	HTREEITEM item = GetTreeCtrl().GetSelectedItem();
	ASSERT(item);
	int nImage, nSelectedImage;
	GetTreeCtrl().GetItemImage(item, nImage, nSelectedImage);
	if (!(nImage == IMAGE_TILE_4 || nImage == IMAGE_TILE_3 || nImage == IMAGE_TILE_8)) {
		AfxMessageBox("Please select a component or port to view its Backward slice.");
		return;
	}

	const char *dottyFileName = "c:\\temp\\fwdreach.dot";
	FILE *f = fopen(dottyFileName, "w");
	ASSERT(f);
	if(nImage == IMAGE_TILE_3) {
		CComponentNode *cNode = (CComponentNode *) GetTreeCtrl().GetItemData(item);
		fprintf(f, "digraph G { \n label=\"type: Backward Slice from %s\";\n",
			 cNode->name); 
		fprintf(f, "size=\"7.5,10\"\n");
		fprintf(f, "page=\"8.5,11\"\n");
		fprintf(f, "nodesep=0.1\n");
		fprintf(f, "node [shape=box,height=.2,width=.1,fontname=Tahoma]\n");

		gTheSystem.theCEDG.reset_color();
		gTheSystem.theCEDG.DFSBackwardSlice(cNode->index, f);
	} else if(nImage == IMAGE_TILE_4 || nImage == IMAGE_TILE_8) {
		CPortNode *pNode = (CPortNode *) GetTreeCtrl().GetItemData(item);
		fprintf(f, "digraph G { \n label=\"type: Backward Slice from %s\";\n",
			 pNode->GetName()); 
		fprintf(f, "size=\"7.5,10\"\n");
		fprintf(f, "page=\"8.5,11\"\n");
		fprintf(f, "nodesep=0.1\n");
		fprintf(f, "node [shape=box,height=.2,width=.1,fontname=Tahoma]\n");

		gTheSystem.thePEDG.reset_color();
		gTheSystem.thePEDG.DFSBackwardSlice(pNode->index, f);
	}

	fprintf(f, "}\n;");
	fclose(f);
	CString command = "dotty " + CString(dottyFileName);
	system(command);
}

void CMyTreeView::OnViewWarningReport() 
{	
	CWarningReportDlg dlg;
	dlg.DoModal();		
}

/*
void CMyTreeView::OnContextMenu(CWnd* pWnd, CPoint point)
{
        UINT uFlags;
        CTreeCtrl&      treeCtrl = GetTreeCtrl();
        CPoint ptTree = point;
        treeCtrl.ScreenToClient(&ptTree);
        HTREEITEM htItem = treeCtrl.HitTest(ptTree, &uFlags);

        if ((htItem != NULL) && (uFlags & TVHT_ONITEM)) {
                ShowPopupMenu( point );
                treeCtrl.SetItemState(htItem, 0, TVIS_DROPHILITED);
        }
        else
                CTreeView::OnContextMenu(pWnd, point);

        if (m_pOldSel != NULL) {
                treeCtrl.Select(m_pOldSel, TVGN_DROPHILITE);
                m_pOldSel = NULL;
        }
}

void CMyTreeView::ShowPopupMenu( CPoint& point )
{
        if (point.x == -1 && point.y == -1){
                //keystroke invocation
                CRect rect;
                GetClientRect(rect);
                ClientToScreen(rect);

                point = rect.TopLeft();
                point.Offset(5, 5);
        }

        CMenu menu;
        VERIFY(menu.LoadMenu(IDR_POPUP));

        CMenu* pPopup = menu.GetSubMenu(0);
        ASSERT(pPopup != NULL);
        CWnd* pWndPopupOwner = this;

        while (pWndPopupOwner->GetStyle() & WS_CHILD)
                pWndPopupOwner = pWndPopupOwner->GetParent();

        pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,
                pWndPopupOwner);
}
*/

#define GET_X_LPARAM(lParam)   ((int)(short)LOWORD(lParam)) 
#define GET_Y_LPARAM(lParam)   ((int)(short)HIWORD(lParam)) 

void CMyTreeView::OnRclick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CRect TreeRect;
	CTreeCtrl&      m_treectrl = GetTreeCtrl();
	HTREEITEM hItem = m_treectrl.GetFirstVisibleItem( );

	// Get the the cursor position into the screen
	DWORD Result = GetMessagePos();
	CPoint ItemPos(GET_X_LPARAM(Result), GET_Y_LPARAM(Result));

	// Retreive the coordinates of the treecrtl viwndow
	m_treectrl.GetWindowRect(&TreeRect);
	ItemPos.Offset(-TreeRect.left, -TreeRect.top);

	// Surche the item which have the focus right click. Is not the same think to the selected
	// item. During the right click, the item receive a selected option, but the selected item 
	// not change.
	while(hItem)
	{
		CRect ItemRect;
		m_treectrl.GetItemRect( hItem, &ItemRect, FALSE );

		// If thye scursor is in the bounding rectangle
		if(ItemRect.PtInRect(ItemPos))
		{
			m_treectrl.SelectItem(hItem);
			ItemPos.Offset(TreeRect.left, TreeRect.top);

			// If the Item is a main parent (no have parent) or have a children, use the SCRIPT_MAIN_
			int image, selectedImage;
			m_treectrl.GetItemImage(hItem, image, selectedImage);
		
			CMenu tmpMenu;
			switch(image) {
			case IMAGE_ROOT: 
				//tmpMenu.LoadMenu(IDR_POPUP);
				return;
			case IMAGE_TILE_2:
				//tmpMenu.LoadMenu(IDR_POPUP);
				return;
			case IMAGE_TILE_3:
				tmpMenu.LoadMenu(IDR_POPUP_COMPONENT);
				break;
			case IMAGE_TILE_4:
				tmpMenu.LoadMenu(IDR_POPUP_PORT);
				break; 

			case IMAGE_TILE_5: 
				//tmpMenu.LoadMenu(IDR_POPUP);
				return;;
			case IMAGE_TILE_6:
				tmpMenu.LoadMenu(IDR_POPUP_PROCESSOR);
				break;
			case IMAGE_TILE_7:
				tmpMenu.LoadMenu(IDR_POPUP_TASK);
				break;
			case IMAGE_TILE_8:
				tmpMenu.LoadMenu(IDR_POPUP_PORT);
				break;
			default:
				ASSERT(0);
			}
			CMenu* pPopup = tmpMenu.GetSubMenu(0);
			ASSERT(pPopup != NULL);
			if(tmpMenu.GetSafeHmenu( ))
			pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
								ItemPos.x, ItemPos.y,
								AfxGetMainWnd()); // use main window for cmds
			break;
		}

		// Get the next visible item.
		hItem = m_treectrl.GetNextVisibleItem( hItem );
	}
	

	*pResult = 0;
}

/*
void CMyTreeView::OnMenuSort() 
{
	HTREEITEM selected_item = GetTreeCtrl().GetSelectedItem();
	GetTreeCtrl().SortChildren(selected_item);
}

*/
void CMyTreeView::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) 
{
	CTreeView::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);
	
		
}

void CMyTreeView::OnMenuCompBslice() 
{
	OnBackwardReachable(); 
	
}

void CMyTreeView::OnMenuCompFslice() 
{
	OnForwardReachable();
	
}

void CMyTreeView::OnMenuPortBslice() 
{
	OnBackwardReachable(); 
	
}

void CMyTreeView::OnMenuPortFslice() 
{
	OnForwardReachable();
	
}

void CMyTreeView::OnUpdateForwardReachable(CCmdUI* pCmdUI) 
{
	HTREEITEM hItem = GetTreeCtrl().GetSelectedItem();
	int image, selectedImage;
	GetTreeCtrl().GetItemImage(hItem, image, selectedImage);
	if(gAIFFileOpened && (image == IMAGE_TILE_3 || image == IMAGE_TILE_4 ||
		image == IMAGE_TILE_8)) {
		pCmdUI->Enable();
	} else {
		pCmdUI->Enable(false);
	}
}

void CMyTreeView::OnUpdateBackwardReachable(CCmdUI* pCmdUI) 
{
	HTREEITEM hItem = GetTreeCtrl().GetSelectedItem();
	int image, selectedImage;
	GetTreeCtrl().GetItemImage(hItem, image, selectedImage);
	pCmdUI->Enable(gAIFFileOpened && (image == IMAGE_TILE_3 || image == IMAGE_TILE_4 ||
		image == IMAGE_TILE_8 ));
}


void CMyTreeView::OnUpdateViewCompGraph(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(gAIFFileOpened);	
}

void CMyTreeView::OnUpdateViewPedg(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(gAIFFileOpened);	
}

void CMyTreeView::OnUpdateViewWarningReport(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(gAIFFileOpened);		
}

void CMyTreeView::OnViewCompslice() 
{
	HTREEITEM hItem = GetTreeCtrl().GetSelectedItem();
	ASSERT(hItem);
	
	int image, selectedImage;
	GetTreeCtrl().GetItemImage(hItem, image, selectedImage);
	ASSERT(image == IMAGE_TILE_7);

	CTaskNode *tNode = (CTaskNode *) GetTreeCtrl().GetItemData(hItem);
	CComponentNode *timerCompNode = gTheSystem.GetTimerCompNode(tNode->GetPeriod());
	if(!timerCompNode) {
		CString temp;
		temp.Format("No component runs at the rate %s, hence there are no dependencies. ",
			GetNameFromRate(tNode->rate));
		AfxMessageBox(temp);
		return;
	}

	const char *dottyFileName = "c:\\temp\\fwdreachtask.dot";
	FILE *f = fopen(dottyFileName, "w");
	ASSERT(f);

	
	fprintf(f, "digraph G { \n label=\"type: Forward Slice from %s\";\n",
		 timerCompNode->name); 
	fprintf(f, "size=\"7.5,10\"\n");
	fprintf(f, "page=\"8.5,11\"\n");
	fprintf(f, "nodesep=0.1\n");
	fprintf(f, "node [shape=box,height=.2,width=.1,fontname=Tahoma]\n");
	gTheSystem.theCEDG.reset_color();
	gTheSystem.theCEDG.DFSForwardSlice(timerCompNode->index, f);

	fprintf(f, "}\n;");
	fclose(f);
	CString command = "dotty " + CString(dottyFileName);
	system(command);
}

void CMyTreeView::OnViewPortSlice() 
{
	HTREEITEM hItem = GetTreeCtrl().GetSelectedItem();
	ASSERT(hItem);
	
	int image, selectedImage;
	GetTreeCtrl().GetItemImage(hItem, image, selectedImage);
	ASSERT(image == IMAGE_TILE_7);

	CTaskNode *tNode = (CTaskNode *) GetTreeCtrl().GetItemData(hItem);
	CComponentNode *timerCompNode = gTheSystem.GetTimerCompNode(tNode->GetPeriod());
	if(!timerCompNode) {
		CString temp;
		temp.Format("No component runs at the rate %s, hence there are no dependencies. ",
			GetNameFromRate(tNode->rate));
		AfxMessageBox(temp);
		return;
	}
	//A timer comp should have only one port
	POSITION pos = timerCompNode->ports.GetHeadPosition();
	CPortNode *pNode = NULL;
	while(pos) {
		pNode = timerCompNode->ports.GetNext(pos);
		break;
	}

	const char *dottyFileName = "c:\\temp\\fwdreachtask.dot";
	FILE *f = fopen(dottyFileName, "w");
	ASSERT(f);

	
	fprintf(f, "digraph G { \n label=\"type: Forward Slice from %s\";\n",
		 timerCompNode->name); 
	fprintf(f, "size=\"7.5,10\"\n");
	fprintf(f, "page=\"8.5,11\"\n");
	fprintf(f, "nodesep=0.1\n");
	fprintf(f, "node [shape=box,height=.2,width=.1,fontname=Tahoma]\n");
	gTheSystem.thePEDG.reset_color();
	gTheSystem.thePEDG.DFSForwardSlice(pNode->index, f);

	fprintf(f, "}\n;");
	fclose(f);
	CString command = "dotty " + CString(dottyFileName);
	system(command);
}

void CMyTreeView::OnUpdateViewPortSlice(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CMyTreeView::OnUpdateViewCompslice(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}
