#if !defined(AFX_MYTREEVIEW_H__5E2A7937_19E7_11D6_8EB9_00010235688C__INCLUDED_)
#define AFX_MYTREEVIEW_H__5E2A7937_19E7_11D6_8EB9_00010235688C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyTreeView.h : header file
//
#define IMAGE_ROOT   0
#define IMAGE_TILE_2 1
#define IMAGE_TILE_3 2
#define IMAGE_TILE_4 3
#define IMAGE_ROOT_SEL   4
#define IMAGE_TILE_2_SEL 5
#define IMAGE_TILE_3_SEL 6
#define IMAGE_TILE_4_SEL 7

#define IMAGE_TILE_5 8
#define IMAGE_TILE_6 9
#define IMAGE_TILE_7 10
#define IMAGE_TILE_8 11
#define IMAGE_TILE_5_SEL 12
#define IMAGE_TILE_6_SEL 13
#define IMAGE_TILE_7_SEL 14
#define IMAGE_TILE_8_SEL 15
/////////////////////////////////////////////////////////////////////////////
// CMyTreeView view
using namespace AIF;

class CMyTreeView : public CTreeView
{
protected:
	CMyTreeView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CMyTreeView)

// Attributes
public:
	
  CImageList ImageList;
  CImageList ImageListSelected;
   HTREEITEM RootItem;
   HTREEITEM RootItem2;
   HTREEITEM CurrentItem;
   enum _what_it_is
      {
         IT_IS_THE_ROOT = 1,
         IT_IS_AN_XML_DOCUMENT,
         IT_IS_AN_ELEMENT,
         IT_IS_A_LIST_OF_ATTRIBUTES,
         IT_IS_AN_ATTRIBUTE
      };
// Operations
public:
	DWORD ImageToWhatItIs( DWORD image_id ) const;
	void DeleteChildren( HTREEITEM parent_item );
	void Populate();
	void SortRecursive(HTREEITEM hItem);
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMyTreeView)
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CMyTreeView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	void	ShowPopupMenu( CPoint& point );
	HTREEITEM m_pOldSel;

	// Generated message map functions
protected:
	//{{AFX_MSG(CMyTreeView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnForwardReachable();
	afx_msg void OnBackwardReachable();
	afx_msg void OnViewWarningReport();
	afx_msg void OnRclick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnMenuFslice();
	afx_msg void OnMenuBslice();
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	afx_msg void OnMenuCompBslice();
	afx_msg void OnMenuCompFslice();
	afx_msg void OnMenuPortBslice();
	afx_msg void OnMenuPortFslice();
	afx_msg void OnUpdateForwardReachable(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBackwardReachable(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewCompGraph(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewPedg(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewWarningReport(CCmdUI* pCmdUI);
	afx_msg void OnViewCompslice();
	afx_msg void OnViewPortSlice();
	afx_msg void OnUpdateViewPortSlice(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewCompslice(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYTREEVIEW_H__5E2A7937_19E7_11D6_8EB9_00010235688C__INCLUDED_)
