// TaskPlotDialog.cpp : implementation file
//

#include "stdafx.h"
#include "Avionics.h"
#include "TaskPlotDialog.h"
#include "TaskPlot/TaskPlotWnd.h"
#include "TaskPlot/RealTimePlot.h"
#include "TaskPlot/TaskPlot.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// TaskPlotDialog dialog


TaskPlotDialog::TaskPlotDialog(CWnd* pParent /*=NULL*/)
	: CDialog(TaskPlotDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(TaskPlotDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void TaskPlotDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(TaskPlotDialog)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(TaskPlotDialog, CDialog)
	//{{AFX_MSG_MAP(TaskPlotDialog)
	ON_BN_CLICKED(IDC_ZOOM_DEF, OnZoomDef)
	ON_BN_CLICKED(IDC_ZOOM_IN, OnZoomIn)
	ON_BN_CLICKED(IDC_ZOOM_OUT, OnZoomOut)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// TaskPlotDialog message handlers

BOOL TaskPlotDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CWnd* pPosition = (CWnd*)GetDlgItem(IDC_TASKPLOT_VIEW);// CStatic
	CreateTaskPlot(pPosition);

	list<TaskPlotData>::iterator ti;
	TaskPlotData aTask;
	int pindex = 0;
/*
	int polish = 0;
	if(policy.sp == PRIORITY_POLICY)
		polish = 0;
	else if(policy.sp == ADVANCED_RMA)
		polish = 1;
*/
//	m_edit_processname.SetWindowText(m_process);

	if(taskdata_list.size() < 1) return FALSE;

	for(ti = taskdata_list.begin();ti!=taskdata_list.end();ti++)
	{
		aTask = *ti;
		InsertTaskPlot(pindex, (char*)(LPCSTR)aTask.name,aTask.period ,aTask.deadline,aTask.wcet,aTask.start,aTask.priority);
	}
	
	//	scheduling_policy : 0=PRIORITY_GIVEN_INCREASE_ORDER, 1=RMA, 2=DM
	ReadyTaskPlot(pindex, 0);
	ShowTaskPlot(pindex);

	CWnd *parentWnd = this->GetParent();
	CFrameWnd *parentFrame = this->GetParentFrame();

	//CWnd *pWnd = AfxGetMainWnd ();
	ASSERT(parentWnd == parentFrame);
		CFrameWnd* pwndMainFrame = (CFrameWnd*)AfxGetMainWnd ();
		CFrameWnd *pwndActiveFrame = pwndMainFrame->GetActiveFrame ();
	ASSERT(parentFrame == pwndActiveFrame);
//	ASSERT(this->IsChild(parentWnd));
//	ASSERT(this->IsChild(parentFrame));
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void TaskPlotDialog::OnZoomDef() 
{
	ZoomTaskPlot(0);
}

void TaskPlotDialog::OnZoomIn() 
{
	ZoomTaskPlot(1);
}

void TaskPlotDialog::OnZoomOut() 
{
	ZoomTaskPlot(-1);
}

void TaskPlotDialog::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void TaskPlotDialog::OnPaint() 
{
//	CPaintDC dc(this); // device context for painting
	
	PAINTSTRUCT ps;
	CDC* pDC = BeginPaint(&ps);

	CWnd* pPosition = (CWnd*)GetDlgItem(IDC_TASKPLOT_VIEW);// CStatic
	CPaintDC dc(pPosition); // device context for painting

	DrawTaskPlot((CDC*)&dc);

	EndPaint(&ps);
}


void TaskPlotDialog::SetTaskInfo(CString processname, int taskindex, CString name, double period, double deadline, double wcet, double offset, int priority)
{
	TaskPlotData aTask;
	int procindex = 0;

	m_process = processname;
	aTask.proc_index = procindex;
	aTask.task_index = taskindex;
	aTask.name = name;
	aTask.period = period;
	aTask.deadline = deadline;
	aTask.wcet = wcet;
	aTask.offset = offset;
	aTask.priority = priority;
	aTask.start = 0;

	taskdata_list.push_front(aTask);
}
