#include "stdafx.h"
#include <math.h>
#include "TaskPlotData.h"

/*
scheduling_policy : 0=PRIORITY_GIVEN_INCREASE_ORDER, 1=RMA, 2=DM
*/
BOOL CTaskScreenArray::Sort(int pindex, int scheduling_policy)
{
	// let's sort based on priority
	int i,j;
	int sp;
	
	sp = scheduling_policy;
	CTaskChannel *aTask, *bTask;

	// check deadlines are set
	for(i=0; i<GetSize(pindex); i++)
	{
		aTask = Get(pindex, i);
		if(fabs(aTask->m_deadline) < 1.0E-6)
			aTask->m_deadline = aTask->m_period;
	}
	
	for(i=0; i < GetSize(pindex)-1; i++)
	{
		for(j=i+1;j<GetSize(pindex);j++)
		{
			double e_i;
			double e_j;
			
			aTask = Get(pindex, i);
			bTask = Get(pindex, j);

			if(sp == 1) //RMA
			{
				e_j = aTask->m_period;
				e_i = bTask->m_period;
			}
			else if(sp == 2)// DM
			{
				e_j = aTask->m_deadline;
				e_i = bTask->m_deadline;
			}
			else if(sp == 0) //PRIORITY_GIVEN_INCREASE_ORDER
			{
				// To follow OSEK, higher number -> higer priority
				e_i = aTask->m_priority;  
				e_j = bTask->m_priority;
			}
			else
			{
				AfxMessageBox("CTaskScreenArray::Sort(int pindex, int scheduling_policy) is wrong.");
				return FALSE;
			}
			
			if(e_j > e_i)
			{
//				CTaskChannel *temp = aTask;
//				aTask = bTask;	bTask = temp;

				Set(pindex, i, bTask);
				Set(pindex, j, aTask);
			}
			else // same priorities
			{
				// remain.
			}
		}
	}
	
//	for(i=0; i<GetSize(pindex); i++)
//	{
//		CString a;
//		a.Format("task %d : %s", i, m_taskdata[pindex][i].name);
//		OutputDebugString((LPCTSTR)a);
//	}

	// Sort end.
	return TRUE;
}
