
#if !defined(__TASKPLOTDATA_H__)
#define __TASKPLOTDATA_H__

#include "ClassArr.h"
#include "Str.h"
#include "TaskChannel.h"
#include <afxtempl.h>

class CTaskChannelArray
{
public:
	CTaskChannelArray()
	{
		m_size = 0;
	}

	~CTaskChannelArray()
	{
		for(int i=0; i< m_size; i++)
		{
			delete (CTaskChannel*)m_ChannelArray[i];
		}
	}

	void Remove(int index) 
	{
		delete m_ChannelArray[index];
	}

	void Add(CTaskChannel *aChannel) 
	{
		m_ChannelArray.Add(aChannel); 
		m_size ++;
	} 

	int GetSize() { return m_size; }

	CTaskChannel* Get(int index) 
	{
		return m_ChannelArray[index];
	}

	void Set(int index, CTaskChannel* aTask) 
	{
		m_ChannelArray[index] = aTask;
	}

public:
	CArray<CTaskChannel*,CTaskChannel*>		m_ChannelArray;
	int	m_size;

};

class CTaskScreenArray
{
public:
	CTaskScreenArray()
	{
		m_size = 0;
	}

	~CTaskScreenArray()
	{
		for(int i=0; i< m_size; i++)
		{
			delete (CTaskChannelArray*)m_ScreenArray[i];
		}
	}

	void AddScreen(CTaskChannelArray *aScreen) 
	{
		m_size ++;

		m_ScreenArray.SetSize(m_size); 
		m_ScreenArray[m_size - 1] = aScreen; 
	} 
	
	CTaskChannel* AddChannel(int pindex) 
	{
		CTaskChannel *aTask = new CTaskChannel;
		
		if(m_size == pindex)
		{
			CTaskChannelArray *aProc = new CTaskChannelArray;
			AddScreen(aProc);
		}
		
		m_ScreenArray[pindex]->Add(aTask);
		return aTask;
	}

	void Remove(int index) 
	{
		delete m_ScreenArray[index];
		m_ScreenArray.RemoveAt(index);
	}

	void Remove(int pindex, int tindex ) 
	{
		CTaskChannelArray* aProcess = Get(pindex);
		aProcess->Remove(tindex);
	}

	int GetSize() { return m_size; }
	int GetSize(int pindex) 
	{ 
		CTaskChannelArray *aProcess;

		if(m_size <= pindex)
			return 0;

		aProcess = m_ScreenArray[pindex];

		return aProcess->GetSize(); 
	}

	CTaskChannelArray* Get(int index) 
	{
		return m_ScreenArray[index];
	}

	CTaskChannel* Get(int pindex, int tindex) 
	{
		CTaskChannelArray *aProcess;
		CTaskChannel *aTask;

		aProcess = m_ScreenArray[pindex];
		aTask = aProcess->Get(tindex);
		return aTask;
	}

	void Set(int pindex, int tindex, CTaskChannel* aTask) 
	{
		CTaskChannelArray *aProcess;

		aProcess = m_ScreenArray[pindex];
		aProcess->Set(tindex, aTask);
	}

	BOOL Sort(int pindex, int scheduling_policy);

public:
	CArray<CTaskChannelArray*, CTaskChannelArray*>	m_ScreenArray;
	int	m_size;
};

#endif
